package PlayTravel.Activity;

import java.io.FilterInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.lang.ref.WeakReference;
import java.net.URL;
import java.util.ArrayList;

import PlayTravel.Data.WayPoint;
import PlayTravel.Database.DB;
import PlayTravel.Map.MapViewOverlay;
import PlayTravel.Map.Marker;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.drawable.Drawable;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.OverlayItem;

public class AlbumMapView extends MapActivity implements OnClickListener{
	private Intent intent;
	private Intent recevedIntent;
	private MapView mapView;
	private DB dbCon;
	private ArrayList<WayPoint> list;
	private GeoPoint point;
	private int albumId;
	private int waypointId;
	private MapViewOverlay itemizedoverlay;
	private boolean albumFlag;
	private int isMyAlbum;
	private BitmapDownloaderTask task;
	private ImageButton scrap_btn;
	

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.albummapview);
		findViewById(R.id.albummapview_home).setOnClickListener(this);
		
		scrap_btn = (ImageButton)findViewById(R.id.scrap_btn);
		
		mapView = (MapView) findViewById(R.id.mapview);
		mapView.setBuiltInZoomControls(true);
		MapController mc = mapView.getController();
		dbCon = new DB();
		list = new ArrayList<WayPoint>();

		recevedIntent = getIntent();
		albumId = recevedIntent.getIntExtra("AlbumID", -1);
		waypointId = recevedIntent.getIntExtra("WaypointID", -1);

		// true: ٹ, false: ٹ
		albumFlag = recevedIntent.getBooleanExtra("AlbumFlag", false);
		
		// true: ٸ ٹ⿡  ٹ
		isMyAlbum = recevedIntent.getIntExtra("isMyAlbum", 0);

		
		ImageView titleBar = (ImageView) findViewById(R.id.maptitlebar);
		if (albumFlag) {
			titleBar.setImageDrawable(this.getResources().getDrawable(
					R.drawable.myalbumview_titlebar));
			scrap_btn.setVisibility(View.GONE);
			
		}else{
			titleBar.setImageDrawable(this.getResources().getDrawable(
					R.drawable.otheralbumview_titlebar));
			scrap_btn.setVisibility(View.VISIBLE);
			scrap_btn.setOnClickListener(this);
		}
		if (albumId != -1) {
				list = dbCon.getWayPointList(albumId);
			
			if (list.size() == 0) {
				Toast.makeText(this, "ϵ ڽ ϴ. ", Toast.LENGTH_SHORT).show();
				finish();
			} else {
				Toast.makeText(this, list.size() + " ڽ ֽϴ.", Toast.LENGTH_SHORT).show();
				
				findViewById(R.id.btn_prev).setOnClickListener(this);
				findViewById(R.id.btn_next).setOnClickListener(this);
				
				Drawable drawable = this.getResources().getDrawable(
						R.drawable.icon_1);

				MapDescription description = new MapDescription();
				itemizedoverlay = new MapViewOverlay(
						this, drawable, list, description, mapView.getController());
				
				//Ŀ ܷ  ʿ
				int[] maxLoca = new int[2];
				int[] minLoca = new int[2];
				maxLoca[0] = -80000000;
				maxLoca[1] = -200000000;
				minLoca[0] = 80000000;
				minLoca[1] = 200000000;
				
				for (int i = 0; i < list.size(); i++) {
					
					int lat = (int)(list.get(i).getX()*1E6);
					int lng = (int)(list.get(i).getY()*1E6);
					
					
					if(lat >= maxLoca[0]){
						maxLoca[0] = lat;
					}
					if(lat < minLoca[0]){
						minLoca[0] = lat;
					}
					
					if(lng >= maxLoca[1]){
						maxLoca[1] = lng;
					}
					if(lng < minLoca[1]){
						minLoca[1] = lng;
					}
					
					// Ŀ߰
					point = new GeoPoint(lat, lng);
					OverlayItem item = new OverlayItem(point, "", "");
					
					//޾ƿ waypointId  ù° ڽ 
					
					if(waypointId == -1){
						waypointId = list.get(0).getId();
					}
					if(waypointId == list.get(i).getId()){ //  Ŀ ũ
						drawable = this.getResources().getDrawable(
								new Marker().getId(1, list.get(i).getCategoryID()));
						
						point = new GeoPoint((int)(list.get(i).getX()*1E6), (int)(list.get(i).getY()*1E6));
						mc.animateTo(point);
						
						//༳ 
						description.setDescription(i);
					}
					else{
						drawable = this.getResources().getDrawable(
								new Marker().getId(0, list.get(i).getCategoryID()));
					}

					item.setMarker(drawable);
					itemizedoverlay.addOverlay(item, drawable);
				}
				mapView.getOverlays().add(itemizedoverlay);
				
				if(list.size() <= 1){
					mc.setZoom(14);
				}
				else{
					// Ŀ ִ, ּ ǥ  ܷ 
					int tmpLat = maxLoca[0]-minLoca[0];
					int tmpLng = maxLoca[1]-minLoca[1];
					
					int zoomLevel1 = (int) (19-(Math.log(tmpLat/1850+1))/Math.log(2));
					int zoomLevel2 = (int) (19-(Math.log(tmpLng/1650+1))/Math.log(2));
					
					if(zoomLevel1 < 1){
						zoomLevel1 = 1;
					}
					if(zoomLevel2 < 1){
						zoomLevel2 = 1;
					}
					
					if(zoomLevel1 <= zoomLevel2){
						mc.setZoom(zoomLevel1);
					}else{
						mc.setZoom(zoomLevel2);
					}
				}
			}
		}
	}

	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		super.onDestroy();
	}

	@Override
	protected void onPause() {
		// TODO Auto-generated method stub
		super.onPause();
	}

	@Override
	protected void onRestart() {
		// TODO Auto-generated method stub
		super.onRestart();
	}

	@Override
	protected void onResume() {
		super.onResume();

	}

	@Override
	protected void onStart() {
		// TODO Auto-generated method stub
		super.onStart();
	}

	@Override
	protected void onStop() {
		// TODO Auto-generated method stub
		super.onStop();
	}

	@Override
	public void onClick(View v) {
		switch (v.getId()) {
		case R.id.albummapview_home:
			intent = new Intent(AlbumMapView.this, Main.class);
			startActivity(intent);
			finish();
			break;
		case R.id.btn_prev:
			itemizedoverlay.onPrev();
			break;
		case R.id.btn_next:
			itemizedoverlay.onNext();
			break;
		case R.id.scrap_btn:
			String result = dbCon.insertScrap(albumId);
			if(result.equals("ok")){
				Toast.makeText(this, "ũ ߰Ǿϴ.", Toast.LENGTH_SHORT).show();
			}else if(result.equals("exist")){
				Toast.makeText(this, "̹ ũ ٹԴϴ.", Toast.LENGTH_SHORT).show();
			}
			break;
		}
	}
	@Override
	protected boolean isRouteDisplayed() {
		// TODO Auto-generated method stub
		return false;
	}

	public class MapDescription {
		LinearLayout layout = (LinearLayout) findViewById(R.id.mapdescription);
		ImageView image = (ImageView) findViewById(R.id.photo);
		TextView course = (TextView) findViewById(R.id.course);
		TextView album = (TextView) findViewById(R.id.albumtitle);
		TextView address = (TextView) findViewById(R.id.address);
		TextView category = (TextView) findViewById(R.id.category);
		TextView dateView = (TextView) findViewById(R.id.date);
		ImageButton btn_detail = (ImageButton) findViewById(R.id.btn_detail);
		
		private int markerIndex = 0;

		//  Ŀ index ޾  ֱ
		public void setDescription(int index) {
			markerIndex = index;
			course.setText("ڽ-" + (index+1));
			album.setText(dbCon.getAlbumInfo(albumId).getName());
			address.setText(list.get(index).getAdress());
			int catId = list.get(index).getCategoryID();
			category.setText(dbCon.getCategoryInfo(catId).getName());
			dateView.setText(list.get(index).getWaydate());
			btn_detail.setOnClickListener(new OnClickListener() {

				@Override
				public void onClick(View v) {
					
					if(albumFlag || isMyAlbum == 1){  //ٹ޴ or ٸٹ⿡ 
						intent = new Intent(AlbumMapView.this, MyAlbumView.class);
					}else{
						intent = new Intent(AlbumMapView.this, OtherAlbumView.class);
					}
					intent.putExtra("WaypointID", list.get(markerIndex).getId());
					intent.putExtra("AlbumID", albumId);
					startActivity(intent);
				}
			});
			
			if(task != null){
				task.cancel(true);
			}
			task = new BitmapDownloaderTask(image);
			task.execute(index);
			
			setVisible();
		}

		public void setVisible() {
			if(layout.getVisibility() == View.GONE){
//				Animation anim = AnimationUtils.loadAnimation(AlbumMapView.this,
//						R.anim.slide_down);
//				layout.startAnimation(anim);
				layout.setVisibility(View.VISIBLE);
			}
			
			layout.setOnClickListener(new OnClickListener() {
				@Override
				public void onClick(View v) {
					setInvisible();
				}
			});
		}

		public void setInvisible() {
//			Animation anim = AnimationUtils.loadAnimation(AlbumMapView.this,
//					R.anim.slide_up);
//			layout.startAnimation(anim);
			layout.setVisibility(View.GONE);
		}
	}

	public class PatchInputStream extends FilterInputStream {
		public PatchInputStream(InputStream in) {
			super(in);
		}

		public long skip(long n) throws IOException {
			long m = 0L;
			while (m < n) {
				long _m = in.skip(n - m);
				if (_m == 0L)
					break;
				m += _m;
			}
			return m;
		}
	}
	
	 class BitmapDownloaderTask extends AsyncTask<Integer, Void, Bitmap> 
	    {
	        private final WeakReference<ImageView> imageViewReference;

	        public BitmapDownloaderTask(ImageView imageView) {
	            imageViewReference = new WeakReference<ImageView>(imageView);
	        }

	        @Override
	        // Actual download method, run in the task thread
	        protected Bitmap doInBackground(Integer... params) {
	             // params comes from the execute() call: params[0] is the url.
	        	
	        	// image URL ڵؼ imageList ־ֱ
				int waypointId = list.get(params[0]).getId();
				try {
					String urlSrc = dbCon.getWayPointImgList(waypointId).get(0).getSrc();
					URL url = new URL(urlSrc);
					InputStream is = url.openStream();
					BitmapFactory.Options options = new BitmapFactory.Options();
					options.inSampleSize = 2;
					Bitmap bitmapImage = BitmapFactory.decodeStream(new PatchInputStream(is), null, options);
					is.close();
					return bitmapImage;
				} catch (IOException e) {
				}

				return null;
	        }

	        @Override
	        // Once the image is downloaded, associates it to the imageView
	        protected void onPostExecute(Bitmap bitmap) {
	            if (isCancelled()) {
	                bitmap = null;
	            }

	            if (imageViewReference != null) {
	                ImageView imageView = imageViewReference.get();
	                if (imageView != null) {
	                    imageView.setImageBitmap(bitmap);
	                    imageView.setScaleType(ImageView.ScaleType.FIT_XY);
	                }
	            }
	        }

	    } 
}
