package PlayTravel.Activity;

import java.io.IOException;
import java.util.List;

import PlayTravel.Map.MyLocationOverlay;
import android.content.Intent;
import android.graphics.drawable.Drawable;
import android.location.Address;
import android.location.Geocoder;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.TextView;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.OverlayItem;

public class LocationModify extends MapActivity implements OnClickListener{
	
    private MapView mapView;
    private MaddressSetting mAddress;
    private Geocoder gc;
    private String address_str;
    private String local_name;
    private double sendLat;
    private double sendLng;
	
    @Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.locationsetting);
		mAddress = new MaddressSetting();
		gc = new Geocoder(this);
		findViewById(R.id.locationsetting_ok).setOnClickListener(this);
		
		Intent recevedIntent = getIntent();
		double x = recevedIntent.getDoubleExtra("x", 37.466044);
		double y = recevedIntent.getDoubleExtra("y", 126.959804);
		updateWithNewLocation(x, y);
	
	}
    
	@Override
	protected void onStop() {
		super.onStop();
	}

	@Override
	public void onClick(View v) {
		switch(v.getId())
		{
		case R.id.locationsetting_ok:
			Intent intent = getIntent();
			intent.putExtra("address", address_str);
			intent.putExtra("x", sendLat);
			intent.putExtra("y", sendLng);
			intent.putExtra("local", local_name); //̸
			setResult(RESULT_OK,intent);
			finish();
			break;
		}
	}
	
	private void updateWithNewLocation(double x, double y)
	{
		
		mapView = (MapView) findViewById(R.id.mapview);
		mapView.setBuiltInZoomControls(true);  
	    MapController mc=mapView.getController();
	        
		Drawable drawable = this.getResources().getDrawable(R.drawable.icon_me); 
		MyLocationOverlay itemizedoverlay = new MyLocationOverlay(this, drawable, mAddress);
       
        GeoPoint point = new GeoPoint((int)(x*1E6),(int)(y*1E6));
        
        OverlayItem item = new OverlayItem(point, "", "");
        item.setMarker(drawable);
        itemizedoverlay.addOverlay(item, drawable);
        mapView.getOverlays().add(itemizedoverlay); 
       
        mc.animateTo(point);
        mc.setZoom(18);
        
        try {
			mAddress.setAddress(x, y);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	
	@Override
	protected boolean isRouteDisplayed() {
		// TODO Auto-generated method stub
		return false;
	}
	
	//ּҷ ȯ
	public class MaddressSetting{
		TextView addressView= (TextView)findViewById(R.id.address);
		
		public void setAddress(double lat, double lng) throws IOException{
			try{
				List<Address> address = gc.getFromLocation(lat, lng, 1);
				address_str = address.get(0).getAddressLine(0);
				addressView.setText(address_str);
				sendLat = lat;
				sendLng = lng;
				local_name = address.get(0).getLocality();
			}catch(Exception e){
				e.printStackTrace();
			}
		}
	}

}

