package PlayTravel.Activity;

import java.util.ArrayList;

import PlayTravel.Data.Album;
import PlayTravel.Database.DB;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Bundle;
import android.telephony.TelephonyManager;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Toast;

public class Main extends Activity implements OnClickListener{
	
	private DB dbCon;	
	private Intent intent;
	private TelephonyManager telManager;
	private boolean flag3G=false;
	private boolean flagWifi=false;
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        SharedPreferences pref = getSharedPreferences("pref", Activity.MODE_PRIVATE);
        flag3G = pref.getBoolean("3G", false);
        flagWifi = pref.getBoolean("Wifi", false);
        ConnectivityManager cm = (ConnectivityManager)getSystemService(Context.CONNECTIVITY_SERVICE);
        NetworkInfo ni = cm.getNetworkInfo(ConnectivityManager.TYPE_WIFI);
        NetworkInfo ni1 = cm.getNetworkInfo(ConnectivityManager.TYPE_MOBILE);
        if(ni.isConnected())
        {
        	if(flagWifi == false)
        	{
        		showDialog(2);
        	}
        }
        else if(ni1.isConnected())
        {
        	if(flag3G == false)
        	{
        		showDialog(0);
        	}
        }
        findViewById(R.id.makealbum).setOnClickListener(this);
        findViewById(R.id.lookotheralbum).setOnClickListener(this);
        findViewById(R.id.looknear).setOnClickListener(this);
        findViewById(R.id.lookmyalbum).setOnClickListener(this);
        findViewById(R.id.scrap).setOnClickListener(this);
        
		dbCon = new DB();		
        telManager = (TelephonyManager)getSystemService(Context.TELEPHONY_SERVICE);
        DB.phoneNumber = telManager.getLine1Number();
        DB.phoneNumber = DB.phoneNumber.replace("+", "");
        //DB.phoneNumber = "821056999631";
        if (DB.phoneNumber == null)
        {
        	Toast.makeText(this, "ȣ ҷü ϴ.  ٽ Ͽ ֽñ ٶϴ.", Toast.LENGTH_SHORT).show();
        	finish();
        	return ;
        }
        
        dbCon.checkMember();
    }
    @Override
	protected void onRestart() { //Back ư 
		// TODO Auto-generated method stub
		super.onRestart();
	}
    @Override
	protected void onStart() {
		// TODO Auto-generated method stub
		super.onStart();
	}
    @Override
	protected void onResume() {
		// TODO Auto-generated method stub
		super.onResume();		
	}

	@Override
	protected void onPause() {
		// TODO Auto-generated method stub
		super.onPause();
		SharedPreferences pref = getSharedPreferences("pref", Activity.MODE_PRIVATE); // UI ¸ մϴ.
    	SharedPreferences.Editor editor = pref.edit(); // Editor ҷɴϴ.
    	editor.putBoolean("3G", flag3G);
    	editor.putBoolean("Wifi", flagWifi);
    	editor.commit();
	}
	
	@Override
	protected void onStop() {
		// TODO Auto-generated method stub
		super.onStop();
	}
	

	@Override
	protected void onDestroy()
	{
		// TODO Auto-generated method stub
		super.onDestroy();
	}
	@Override
	protected Dialog onCreateDialog(int id) {
		// TODO Auto-generated method stub
		switch(id)
		{
		case 0 :
			return new AlertDialog.Builder(Main.this)
            .setTitle("")
            .setMessage("񽺴 Ʈũ ̿ϴ 񽺷 3G ̾ Ϸ մϴ.    ΰ ɼֽϴ. Ͻʴϱ?\n(ʹ Ÿ)")
            .setCancelable(false)
            .setPositiveButton("", new DialogInterface.OnClickListener() {
                public void onClick(DialogInterface dialog, int whichButton) {
                	
                    /* User clicked OK so do some stuff */
                	flag3G = true;
                }
            })
            .setNegativeButton("ź", new DialogInterface.OnClickListener() {
                public void onClick(DialogInterface dialog, int whichButton) {
                    /* User clicked Cancel so do some stuff */
                	finish();
                }
            })
            .create();
		case 2 :
			return new AlertDialog.Builder(Main.this)
            .setTitle("")
            .setMessage("񽺴³Ʈũ̿ϴ¼񽺷 WiFi   Ϸ մϴ. ȭ ߻ ʽϴ. Ͻðڽϱ? \n(ʹ Ÿ )")
            .setCancelable(false)
            .setPositiveButton("", new DialogInterface.OnClickListener() {
                public void onClick(DialogInterface dialog, int whichButton) {
                	
                    /* User clicked OK so do some stuff */
                	flagWifi = true;
                }
            })
            .setNegativeButton("ź", new DialogInterface.OnClickListener() {
                public void onClick(DialogInterface dialog, int whichButton) {
                    /* User clicked Cancel so do some stuff */
                	finish();
                }
            })
            .create();
		}
		return null;
	}
	@Override
	public void onClick(View v) 
	{
		// TODO Auto-generated method stub
		switch(v.getId())
		{
		case R.id.makealbum :
			intent = new Intent(Main.this,MakeAlbum.class);
			startActivity(intent);
			break;
		case R.id.lookotheralbum :
			intent = new Intent(Main.this,OtherAlbumList.class);
			intent.putExtra("themecateID",0);
			intent.putExtra("themecateName","ü");
			intent.putExtra("locationcateName","ü");
			intent.putExtra("locationcateID","0");
			startActivity(intent);
			break;
		case R.id.looknear :
			intent = new Intent(Main.this,NearMapView.class);
			startActivity(intent);
			break;
		case R.id.lookmyalbum :			
			dbCon = new DB();
			ArrayList<Album> albums = dbCon.getAlbumList(1,1,10,"0",0);
			Integer tmp;
			tmp = albums.size();
			if (albums.size() == 0)
			{
				Toast.makeText(this, "Ͻ ٹ  ʽϴ.", Toast.LENGTH_SHORT).show();
	        	return ;
			}
			
			intent = new Intent(Main.this,MyAlbumList.class);
			startActivity(intent);
			break;
		case R.id.scrap:
			dbCon = new DB();
			ArrayList<Album> scrab = dbCon.getAlbumList(3,1,10,"0",0);
			Integer temp;
			temp = scrab.size();
			if (scrab.size() == 0)
			{
				Toast.makeText(this, "Ͻ ũ  ʽϴ.", Toast.LENGTH_SHORT).show();
	        	return ;
			}
			intent = new Intent(Main.this,Scrab.class);
			startActivity(intent);
			break;
		}
		
	}

}