package PlayTravel.Activity;

import java.io.File;
import java.io.FileOutputStream;
import java.io.FilterInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Calendar;

import PlayTravel.Data.Category;
import PlayTravel.Data.WayPoint;
import PlayTravel.Data.WayPointImg;
import PlayTravel.Database.DB;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.app.AlertDialog.Builder;
import android.content.DialogInterface;
import android.content.Intent;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.net.Uri;
import android.os.Bundle;
import android.provider.MediaStore;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.webkit.MimeTypeMap;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.Spinner;
import android.widget.Toast;

public class ModifyAlbum extends Activity implements OnClickListener{
	private Intent intent;
	private DB dbCon;	
	ArrayList<Category> category = null;	
	private ArrayAdapter<String> adapter = null;
	ArrayList<WayPointImg> wayPointImgList = null;
	private Integer lastAlbumID = 0;
	private ImageView img_1 = null;
	private ImageView img_2 = null;
	private ImageView img_3 = null;
	private ImageView img_4 = null;
	private ImageView img_5 = null;
	private ImageView img_1_back = null;
	private ImageView img_2_back = null;
	private ImageView img_3_back = null;
	private ImageView img_4_back = null;
	private ImageView img_5_back = null;
	private ImageView nowImgView = null;
	private Button getLocation = null;
	private Spinner spin = null;
	private EditText commentModify = null; 
	
	private String address = null;
	private Double x = null;
	private Double y = null;
	private String local = null;
	private Integer categoryID = null;
	private String coment = null;
	private ArrayList<String> imgs = null;
	private ArrayList<Integer> ids = null;
	private ArrayList<Integer> types = null;
	
	private Intent receivedIntent;
	private Integer WaypointID;
	private Integer modifyIndex = 0;
	
	private ProgressDialog dialog;
	
	private String comment;
	private Integer selectedId;
	
	private Bitmap bits[];
	
	private ImageView wasteBasket = null;
	private Bitmap nonImage = null;
	private Bitmap nonSmallImage = null;
	
	private Bitmap bit = null;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		setContentView(R.layout.modifyalbum);
		
		findViewById(R.id.modifyalbum_home).setOnClickListener(this);
		findViewById(R.id.saveBtnModify).setOnClickListener(this);
		findViewById(R.id.captureBtnModify).setOnClickListener(this);
		findViewById(R.id.selBtnModify).setOnClickListener(this);
		findViewById(R.id.delWayPoint).setOnClickListener(this);
		spin = (Spinner) findViewById(R.id.categoryModify);
		getLocation = (Button) findViewById(R.id.getLocationModify);
		getLocation.setOnClickListener(this);
		nowImgView = (ImageView) findViewById(R.id.nowImgModify2);
		
		img_1 = (ImageView) findViewById(R.id.imgModify_1);
		img_2 = (ImageView) findViewById(R.id.imgModify_2);
		img_3 = (ImageView) findViewById(R.id.imgModify_3);
		img_4 = (ImageView) findViewById(R.id.imgModify_4);
		img_5 = (ImageView) findViewById(R.id.imgModify_5);
		img_1_back = (ImageView) findViewById(R.id.imgModify_1_back);
		img_2_back = (ImageView) findViewById(R.id.imgModify_2_back);
		img_3_back = (ImageView) findViewById(R.id.imgModify_3_back);
		img_4_back = (ImageView) findViewById(R.id.imgModify_4_back);
		img_5_back = (ImageView) findViewById(R.id.imgModify_5_back);
		commentModify = (EditText) findViewById(R.id.commentModify);
		
		bits = new Bitmap[5];
		
		img_1.setOnClickListener(this);
		img_2.setOnClickListener(this);
		img_3.setOnClickListener(this);
		img_4.setOnClickListener(this);
		img_5.setOnClickListener(this);	
		img_1_back.setOnClickListener(this);
		img_2_back.setOnClickListener(this);
		img_3_back.setOnClickListener(this);
		img_4_back.setOnClickListener(this);
		img_5_back.setOnClickListener(this);
		
		wasteBasket = (ImageView) findViewById(R.id.wastebasketModify);		
		
		nonImage = BitmapFactory.decodeResource(getResources(), R.drawable.blank_image);
		nonSmallImage = BitmapFactory.decodeResource(getResources(), R.drawable.blank_image);
		
		wasteBasket.setOnClickListener(this);
		
		dbCon = new DB();
		
		receivedIntent = getIntent();
		WaypointID = receivedIntent.getIntExtra("WaypointID", -1);
		WayPoint wayPointInfo = dbCon.getWayPointInfo(WaypointID);
		wayPointImgList =  dbCon.getWayPointImgList(WaypointID);
		
		imgs  = new ArrayList<String>();		
		ids  = new ArrayList<Integer>();	
		types  = new ArrayList<Integer>();	
		
		category = dbCon.getCategoryList();  
		lastAlbumID = wayPointInfo.getAlbumID();
		
		
		ArrayList<String> items = null;
		items = new ArrayList<String>();
		
		for (Integer i = 0 ; i < category.size() ;i++)
		{
			items.add(category.get(i).getName());				
		}
		
		adapter = new ArrayAdapter<String>(this,android.R.layout.simple_spinner_item,items);
		adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		spin.setAdapter(adapter);
		
		initInfo(wayPointInfo);
		initImgs(wayPointImgList);	
		
	}
	
	 
	
	public void initInfo(WayPoint wayPointInfo)
	{		
		address = wayPointInfo.getAdress();
		x = wayPointInfo.getX();
		y = wayPointInfo.getY();
		local = wayPointInfo.getLocal();
		categoryID = wayPointInfo.getCategoryID();
		coment = wayPointInfo.getComent();
		
		commentModify.setText(coment);
		
		String tmpStr = null;
		try{
			tmpStr = address.substring(0,20) + "...";
		}catch(Exception e){
			tmpStr = address;
		}
		getLocation.setText(tmpStr);
		
		for (Integer i = 0 ; i < 5 ;i++)
		{
			imgs.add("");
			ids.add(-1);
			types.add(0);
		}
		
		for (Integer i = 0 ; i < category.size() ;i++)
		{
			if (category.get(i).getId() == categoryID)
			{
				spin.setSelection(i);
				break;
			}
		}		
	}
	
	public void initImgs(ArrayList<WayPointImg> wayPointImgList )
	{
		try {
			for (Integer i = 0 ; i < wayPointImgList.size() ; i++)
			{ 
				String tmpSrc = wayPointImgList.get(i).getSrc();
			
			
				InputStream bis = new java.net.URL(wayPointImgList.get(i).getSrc()).openStream();
			    
				BitmapFactory.Options options = new BitmapFactory.Options();
				//options.inSampleSize = 2;
				bit = BitmapFactory.decodeStream(new PatchInputStream(bis),null,options);
				
				switch(i)
				{
					case 0 :
						img_1.setImageBitmap(bit);
						break;
					case 1 : 
						img_2.setImageBitmap(bit);
						break;
					case 2 : 
						img_3.setImageBitmap(bit);
						break;
					case 3 : 
						img_4.setImageBitmap(bit);
						break;
					case 4 : 
						img_5.setImageBitmap(bit);
						break;
				}
				
				if (i == 0)
				{
					nowImgView.setImageBitmap(bit);
					changeBackImg(i);
				}
				
				bits[i] = bit;
				imgs.set(i, tmpSrc);
				types.set(i, 4);
				//ids.set(i, wayPointImgList.get(i).getId());
			}			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			Toast.makeText(this, "޸ Ǵ Ʈũ Դϴ.  ٽ õ ֽñ ٶϴ.", Toast.LENGTH_SHORT).show();
			finish();
		}	
	}
	
	public class PatchInputStream extends FilterInputStream {
		  public PatchInputStream(InputStream in) {
		    super(in);
		  }
		  public long skip(long n) throws IOException {
		    long m = 0L;
		    while (m < n) {
		      long _m = in.skip(n-m);
		      if (_m == 0L) break;
		      m += _m;
		    }
		    return m;
		  }
	}
	
	@Override
	protected void onRestart() {
		// TODO Auto-generated method stub
		super.onRestart();
	}
	@Override
	protected void onStart() {
		// TODO Auto-generated method stub
		super.onStart();
	}
	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		super.onResume();		
	}
	
	 @Override
		protected void onActivityResult(int requestCode, int resultCode, Intent data){
			super.onActivityResult(requestCode, resultCode, data);;
			if(resultCode==RESULT_OK)
			{
				if(requestCode==1)
				{
					try{
						
						BitmapFactory.Options options = new BitmapFactory.Options();
				         options.inSampleSize =4; //̹ ö 1/8 ũ .
				         Bitmap bit = BitmapFactory.decodeFile("/sdcard/playtravel/temp.jpg",options);
												
						String imgName = "";
						Long tmpCal = null;
						Calendar cal = Calendar.getInstance();
						tmpCal = cal.getTimeInMillis();
						imgName = tmpCal.toString() + ".jpg";
						
						String FILE_ROOT = "/sdcard/";
	                	String dirName = "playtravel";
	                	String fullSrc = FILE_ROOT + dirName + "/" + imgName;    	                	
	                	
	                	File directory = new File(FILE_ROOT + dirName + "/");                         	
                    	
                    	
                    	if (directory.exists() == false)
                    	{
                    		directory.mkdir();                        	
                    	}                    	
                    	
                    	FileOutputStream fos;                        	                            
                        fos = new FileOutputStream(fullSrc);
                        bit.compress(Bitmap.CompressFormat.JPEG, 100, fos);
                        fos.close();                         
                        	
						
						switch(modifyIndex)
						{
							case 0 : 
								img_1.setImageBitmap(bit);
								break;
							case 1 : 
								img_2.setImageBitmap(bit);
								break;
							case 2 : 
								img_3.setImageBitmap(bit);
								break;
							case 3 : 
								img_4.setImageBitmap(bit);
								break;
							case 4 : 
								img_5.setImageBitmap(bit);
								break;
						}
									
						nowImgView.setImageBitmap(bit);						
						
						bits[modifyIndex] = bit;
						if (types.get(modifyIndex) == 4 || types.get(modifyIndex) == 5)
						{
							ids.set(modifyIndex, wayPointImgList.get(modifyIndex).getId());
							types.set(modifyIndex, 2);
						}
						else
						{
							ids.set(modifyIndex, 0);
							types.set(modifyIndex, 1);
						}
						
						imgs.set(modifyIndex,fullSrc);		
						
						changeBackImg(modifyIndex);
						
					}catch (Exception e) {
					}
					
				}
				else if(requestCode==2)
				{					
					address = (String) data.getStringExtra("address");
					x = data.getDoubleExtra("x", 0);
					y = data.getDoubleExtra("y", 0);
					local = (String) data.getStringExtra("local");
					String tmpStr = null;
					tmpStr = address.substring(0,15) + "...";
					getLocation.setText(tmpStr);
				}
				else if(requestCode==3)
				{					
					try{
						Uri curImgURI = data.getData(); 
						String tmpSrc = this.getPath(curImgURI); 
						
						BitmapFactory.Options options = new BitmapFactory.Options();
						//options.inSampleSize = 4;
						options.outHeight = 480;
						options.outWidth = 640;
						bit = BitmapFactory.decodeFile(tmpSrc, options);
						
						switch(modifyIndex)
						{
							case 0 : 
								img_1.setImageBitmap(bit);
								break;
							case 1 : 
								img_2.setImageBitmap(bit);
								break;
							case 2 : 
								img_3.setImageBitmap(bit);
								break;
							case 3 : 
								img_4.setImageBitmap(bit);
								break;
							case 4 : 
								img_5.setImageBitmap(bit);
								break;
						}					
									
						
						nowImgView.setImageBitmap(bit);	
						bits[modifyIndex] = bit;
						if (types.get(modifyIndex) == 4 || types.get(modifyIndex) == 5)
						{
							ids.set(modifyIndex, wayPointImgList.get(modifyIndex).getId());
							types.set(modifyIndex, 2);
						}
						else
						{
							ids.set(modifyIndex, 0);
							types.set(modifyIndex, 1);
						}
						
						imgs.set(modifyIndex,tmpSrc);
						changeBackImg(modifyIndex);
					}catch (Exception e) {
						// TODO: handle exception
					}				
				}				
			}
		}
	 
	@Override
	protected void onPause() {
		// TODO Auto-generated method stub
		super.onPause();
	}

	@Override
	protected void onStop() {
		// TODO Auto-generated method stub
		super.onStop();
	}
	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		super.onDestroy();
		try{
			for (Integer i = 0 ; i < 5 ; i++)
			{
				bits[i].recycle();
			}
			
			bit.recycle();
		}catch(Exception e) {
			// TODO: handle exception///
		}
		
	}
	@Override
	public void onClick(View v) {
		// TODO Auto-generated method stub
		Uri pictureUri;
		
		switch(v.getId())
		{
			case R.id.captureBtnModify :				
				String FILE_ROOT = "/sdcard/";
            	String dirName = "playtravel"; 	                	
            	
            	File directory = new File(FILE_ROOT + dirName + "/");                     	
            	
            	
            	if (directory.exists() == false)
            	{
            		directory.mkdir();                        	
            	}              
            	
				pictureUri = Uri.fromFile(new File("/sdcard/playtravel/temp.jpg")); 
				
				intent = new Intent(android.provider.MediaStore.ACTION_IMAGE_CAPTURE);
				intent.putExtra(MediaStore.EXTRA_OUTPUT, pictureUri); 
				startActivityForResult(intent,1);						
			break;			
			case R.id.modifyalbum_home :
				intent = new Intent(ModifyAlbum.this,Main.class);
				startActivity(intent);
				finish();
				break;
			case R.id.getLocationModify :
				intent = new Intent(ModifyAlbum.this,LocationModify.class);
				intent.putExtra("x", x);
				intent.putExtra("y", y);
				startActivityForResult(intent,2);
				break;
			case R.id.saveBtnModify:				
				checkInfo();
			break;	
			case R.id.selBtnModify:
				intent = new Intent(); 
                intent.setType("image/*"); 
                intent.setAction(Intent.ACTION_GET_CONTENT); 
                startActivityForResult(Intent.createChooser(intent, 
                        "Select Picture"), 3); 
			break;
			case R.id.delWayPoint:
				showDialog(1);
			break;
			case R.id.imgModify_1:	
				changeImg(0);
			break;	
			case R.id.imgModify_2:	
				changeImg(1);
			break;	
			case R.id.imgModify_3:
				changeImg(2);
			break;	
			case R.id.imgModify_4:
				changeImg(3);
			break;	
			case R.id.imgModify_5:
				changeImg(4);
			break;	
			case R.id.wastebasketModify:
				deleteImage();
			break;
		}		
	}
	
	
	private void deleteImage()
	{
		if (imgs.get(modifyIndex).equals("")) return ;		
		
		showDialog(0);
	}
	
	private void setNonImage(Integer index)
	{
		switch(index)
		{
			case 0:
				img_1.setImageBitmap(nonSmallImage);
			break;	
			case 1:	
				img_2.setImageBitmap(nonSmallImage);
			break;	
			case 2:
				img_3.setImageBitmap(nonSmallImage);
			break;	
			case 3:
				img_4.setImageBitmap(nonSmallImage);
			break;	
			case 4:
				img_5.setImageBitmap(nonSmallImage);
			break;	
		}
		
		nowImgView.setImageBitmap(nonImage);
		
		imgs.set(modifyIndex,"");
		if (types.get(modifyIndex) == 4 || types.get(modifyIndex) == 5)
		{
			ids.set(modifyIndex, wayPointImgList.get(modifyIndex).getId());			
		}
		else
		{
			ids.set(modifyIndex, 0);
		}		
		bits[modifyIndex].recycle();
		bits[modifyIndex] = null;
		types.set(modifyIndex, 5);
	}
	
	@Override
    protected Dialog onCreateDialog(int id) {
		Builder di;
		switch (id) 
		{
	        case 0:
	            // This example shows how to add a custom layout to an AlertDialog
	            di =  new AlertDialog.Builder(ModifyAlbum.this);
	            di.setTitle("Warning");
	            di.setMessage("  Ͻðڽϱ?");
	            di.setPositiveButton("Ok", new DialogInterface.OnClickListener() {
	                public void onClick(DialogInterface dialog, int whichButton) {	
	                    /* User clicked OK so do some stuff */                	
	                	setNonImage(modifyIndex);
	                }
	            });
	            di.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
	                public void onClick(DialogInterface dialog, int whichButton) {
	                    /* User clicked Cancel so do some stuff */
	                }
	            });
	            return di.create();
	        case 1:
	        	// This example shows how to add a custom layout to an AlertDialog
	            di =  new AlertDialog.Builder(ModifyAlbum.this);
	            di.setTitle("Warning");
	            di.setMessage(" ڽ  Ͻðڽϱ?");
	            di.setPositiveButton("Ok", new DialogInterface.OnClickListener() {
	                public void onClick(DialogInterface dialog, int whichButton) {	
	                    /* User clicked OK so do some stuff */
	                	String res = "";
	                	res = dbCon.deleteWayPoint(WaypointID);
	                	
	                	if (res.equals("ok"))
	                	{
	                		intent = new Intent(ModifyAlbum.this,AlbumMapView.class);	                		
							intent.putExtra("AlbumFlag", true);
							intent.putExtra("AlbumID", lastAlbumID);
							startActivity(intent);
							finish();			
	                	}
	                }
	            });
	            di.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
	                public void onClick(DialogInterface dialog, int whichButton) {
	                    /* User clicked Cancel so do some stuff */
	                }
	            });
	            return di.create();
		}
		return null;
	}
	
	public void changeImg(Integer index)
	{		
		try{
			modifyIndex = index;			
		
			nowImgView.setImageBitmap(bits[modifyIndex]);	
			
			changeBackImg(index);
			
		}catch (Exception e) {
			// TODO: handle exception
		}
		
	}
	
	public void changeBackImg(Integer index)
	{
		try{
			
			for (Integer i = 0 ; i < 5 ; i++)
			{
				switch(i)
				{
					case 0 : 
						img_1_back.setBackgroundColor(Color.WHITE);
						break;
					case 1 : 
						img_2_back.setBackgroundColor(Color.WHITE);
						break;
					case 2 : 
						img_3_back.setBackgroundColor(Color.WHITE);
						break;
					case 3 : 
						img_4_back.setBackgroundColor(Color.WHITE);
						break;
					case 4 : 
						img_5_back.setBackgroundColor(Color.WHITE);
						break;
				}
			}
			
			
			switch(index)
			{
				case 0 : 
					img_1_back.setBackgroundColor(Color.rgb(134, 28, 0));
					break;
				case 1 : 
					img_2_back.setBackgroundColor(Color.rgb(134, 28, 0));
					break;
				case 2 : 
					img_3_back.setBackgroundColor(Color.rgb(134, 28, 0));
					break;
				case 3 : 
					img_4_back.setBackgroundColor(Color.rgb(134, 28, 0));
					break;
				case 4 : 
					img_5_back.setBackgroundColor(Color.rgb(134, 28, 0));
					break;
			}
		}catch (Exception e) {
			// TODO: handle exception
		}
	}
	
	private Integer getImageCount()
	{
		Integer count = 0;
		
		if (imgs == null) return 0;	
		
		for (Integer i = 0 ; i < imgs.size() ; i++)
		{
			if (!imgs.get(i).equals(""))
				count++;
		}	
		
		return count;
	}
	
	public String getPath(Uri uri) { 
	    String[] projection = { MediaStore.Images.Media.DATA }; 
	    Cursor cursor = managedQuery(uri, projection, null, null, null); 
	    int column_index = cursor 
	            .getColumnIndexOrThrow(MediaStore.Images.Media.DATA); 
	    cursor.moveToFirst(); 
	    return cursor.getString(column_index); 
	} 

		
	//ʿ   Է Ǿ üũ
	public void checkInfo()
	{
		final Spinner spin = (Spinner) findViewById(R.id.categoryModify);
		EditText commentEditText = (EditText) findViewById(R.id.commentModify);
		comment = commentEditText.getText().toString();
		selectedId = getSelectedItem(category,spin.getSelectedItem().toString());
		
		if (getImageCount() < 1)
		{
			Toast.makeText(this, " ּ", Toast.LENGTH_SHORT).show();
			return ;
		}
		
		if (comment.equals(""))
		{
			Toast.makeText(this, "ڸƮ Էּ", Toast.LENGTH_SHORT).show();
			return ;
		}
		
		if (selectedId == 0)
		{
			Toast.makeText(this, "error ڿ ϼ", Toast.LENGTH_SHORT).show();
			return ;
		}
		
		if (address == null)
		{
			Toast.makeText(this, "  ּ", Toast.LENGTH_SHORT).show();
			return ;
		}
		
		dialog = ProgressDialog.show(ModifyAlbum.this, "", "...",true);
		processThread();		
		
	}
	
	public void processThread(){
		Runnable r = new Runnable() {
			public void run() {
				try{
					String res = null;//
					
					res = dbCon.updateWayPoint(comment, x, y, selectedId, address, lastAlbumID,local,imgs,ids,WaypointID,types);
					
					if (res.equals("ok"))
					{			
						intent = new Intent(ModifyAlbum.this,AlbumMapView.class);
						intent.putExtra("AlbumFlag", true);
						intent.putExtra("AlbumID", lastAlbumID);
						
						
						
						intent.putExtra("WaypointID", WaypointID);
						startActivity(intent);
						finish();			
					}
				}catch (Exception e) {
					// TODO: handle exception
					dialog.dismiss();
				}				
			}
		};
		Thread t1 = new Thread(r);
		t1.start();
	}	
	
	//õ ׸ ̵ ...
	public Integer getSelectedItem(ArrayList<Category> category, String findText)
	{
		for (Integer i = 0 ; i < category.size() ;i++)
		{
			if (category.get(i).getName().toString().equals(findText))
			{
				return category.get(i).getId();
			}
        }
		return -1;
	}
}
