 package PlayTravel.Activity;

import java.io.FilterInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;

import PlayTravel.Data.Reply;
import PlayTravel.Data.WayPoint;
import PlayTravel.Data.WayPointImg;
import PlayTravel.Database.DB;
import android.app.ListActivity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.ProgressBar;
import android.widget.TextView;
import android.widget.Toast;

public class MyAlbumView extends ListActivity implements OnClickListener
{
	private Intent receivedIntent;
	private Intent intent;
	private ListView albumList;
	private	 ViewAdapter adapter;
	private DB dbCon;
	private int CourceID;
	private TextView comment;
	private TextView courceReply;
	private int WaypointID;
	private int AlbumID;
	private ArrayList<WayPoint> wayPoint;
	private	int index;
	private ArrayList<WayPointImg> wayPointImg;
	private boolean onCreateFlag;
	private ArrayList<Reply> reply ;
	private ProgressDialog dialog;
	private WayPoint wayPointInfo;
	private ImageButton prevBtn;
	private ImageButton nextBtn;
	private ProgressBar progress;
	
	
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		setContentView(R.layout.myalbumview);
		onCreateFlag =true;
		courceReply = (TextView)findViewById(R.id.replytext);
		courceReply.setOnClickListener(this);
		findViewById(R.id.myalbumview_home).setOnClickListener(this);
		progress = (ProgressBar)findViewById(R.id.myalbumview_progress);
		prevBtn = (ImageButton)findViewById(R.id.btncourceprev);
		prevBtn.setOnClickListener(this);
		nextBtn=(ImageButton)findViewById(R.id.btncourcenext);
		nextBtn.setOnClickListener(this);
		prevBtn.setClickable(false);
		nextBtn.setClickable(false);
		findViewById(R.id.btnmapview).setOnClickListener(this);
		findViewById(R.id.btnEdit).setOnClickListener(this);
		comment = (TextView)findViewById(R.id.myalbumview_comment);
//		image = new ArrayList<Bitmap>();
		wayPoint = new ArrayList<WayPoint>();
		wayPointImg = new ArrayList<WayPointImg>();
		dbCon = new DB();
		receivedIntent = getIntent();
		WaypointID = receivedIntent.getIntExtra("WaypointID", -1);
		AlbumID = receivedIntent.getIntExtra("AlbumID", -1);	
		
		
	}
	@Override
	protected void onRestart() {
		// TODO Auto-generated method stub
		super.onRestart();
	}
	@Override
	protected void onStart() {
		// TODO Auto-generated method stub
		super.onStart();
	}
	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		super.onResume();
		comment.setText("");
		albumList = null;
		albumList = getListView();
		UIloaderTask task = new UIloaderTask();
        task.execute();
        
	}
	@Override
	protected void onPause() {
		// TODO Auto-generated method stub
		super.onPause();
	}

	@Override
	protected void onStop() {
		// TODO Auto-generated method stub
		super.onStop();
	}
	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		super.onDestroy();
	}
	@Override
	public void onClick(View v) {
		// TODO Auto-generated method stub
		switch(v.getId())
		{
		case R.id.myalbumview_home:
			intent = new Intent(MyAlbumView.this,Main.class);
			startActivity(intent);
			finish();
			break;
		case R.id.btncourceprev:
			
			if(index != 0)
			{
				progress.setVisibility(View.VISIBLE);
				index--;
				WaypointID = wayPoint.get(index).getId();
				prevBtn.setClickable(false);
				nextBtn.setClickable(false);
				onResume();
			}
			else
			{
				Toast.makeText(this, "ù°ڽԴϴ", 500).show();
			}
						
			break;
			
		case R.id.btncourcenext:
			
			if(index != wayPoint.size()-1)
			{
				progress.setVisibility(View.VISIBLE);
				index++;
				WaypointID = wayPoint.get(index).getId();
				prevBtn.setClickable(false);
				nextBtn.setClickable(false);
				onResume();
			}
			else
			{
				Toast.makeText(this, "ڽԴϴ", 500).show();
			}
			break;
		case R.id.btnEdit:
			dialog = ProgressDialog.show(MyAlbumView.this, "", "ҷ...",true);
			processThread();				
			break;
		case R.id.btnmapview:
			intent = new Intent(MyAlbumView.this,AlbumMapView.class);
			intent.putExtra("AlbumID",AlbumID);
			intent.putExtra("WaypointID",WaypointID);
			intent.putExtra("AlbumFlag", true);
			startActivity(intent);
			break;
		case R.id.replytext :
			intent =  new Intent(MyAlbumView.this,ReviewList.class);
			intent.putExtra("WaypointID", WaypointID);
			intent.putExtra("isMyAlbum", true);
			startActivity(intent);
			
		}
		
	}

	public void processThread(){
		Runnable r = new Runnable() {
			public void run() {
				try{
					intent = new Intent(MyAlbumView.this,ModifyAlbum.class);
					intent.putExtra("WaypointID", WaypointID);
					startActivity(intent);
					dialog.dismiss();
				}catch (Exception e) {
					// TODO: handle exception
					dialog.dismiss();
				}				
			}
		};
		Thread t1 = new Thread(r);
		t1.start();
	}	
	
	class ViewAdapter extends BaseAdapter
	{

		@Override
		public int getCount() {
			// TODO Auto-generated method stub
			return wayPointImg.size();
		}

		@Override
		public Object getItem(int position) {
			// TODO Auto-generated method stub
			return null;
		}

		@Override
		public long getItemId(int position) {
			// TODO Auto-generated method stub
			return 0;
		}

		@Override
		public View getView(int position, View convertView, ViewGroup parent) {
			// TODO Auto-generated method stub
			ViewHolder holder;
			View v = convertView;
			if(v ==null)
			{
				LayoutInflater vi = (LayoutInflater)getSystemService(Context.LAYOUT_INFLATER_SERVICE);
				v = vi.inflate(R.layout.myalbumviewrow, null);
				holder = new ViewHolder();
				holder.courceImg = (ImageView)v.findViewById(R.id.courceImg);
				v.setTag(holder);
				
			}
			else
			{
				holder = (ViewHolder)v.getTag();
			}
		
				if(wayPointImg.get(position).getMyBitmap() != null)
				{
					holder.courceImg.setImageBitmap(wayPointImg.get(position).getMyBitmap());
					holder.courceImg.setScaleType(ImageView.ScaleType.FIT_XY);
				}
				else
				{
					holder.courceImg.setImageResource(R.drawable.blank_image);
					holder.courceImg.setScaleType(ImageView.ScaleType.FIT_XY);
				}
			return v;
		}

		
		
		
	}
	static class ViewHolder
	{	
		ImageView courceImg;			
	}	
	class FlushedInputStream extends FilterInputStream {
	    public FlushedInputStream(InputStream inputStream) {
	        super(inputStream);
	    }

	    @Override
	    public long skip(long n) throws IOException {
	        long totalBytesSkipped = 0L;
	        while (totalBytesSkipped < n) {
	            long bytesSkipped = in.skip(n - totalBytesSkipped);
	            if (bytesSkipped == 0L) {
	                  int bite = read();
	                  if (bite < 0) {
	                      break;  // we reached EOF
	                  } else {
	                      bytesSkipped = 1; // we read one byte
	                  }
	           }
	            totalBytesSkipped += bytesSkipped;
	        }
	        return totalBytesSkipped;
	    }
	}
                                                                                     // Param, Progress, Result
    class UIloaderTask extends AsyncTask<String,Void, String> 
    {
//        private final WeakReference<ImageView> imageViewReference;
        
        @Override
        // Actual download method, run in the task thread
        protected String doInBackground(String... str) {
             // params comes from the execute() call: params[0] is the url.
        	if(onCreateFlag == true)
        	{
	        	wayPoint = dbCon.getWayPointList(AlbumID);
	        	
	    		for(int i=0;i<wayPoint.size();i++)
	    		{
	    			if(wayPoint.get(i).getId() == WaypointID)
	    			{
	    				index =i;
	    				break;
	    			}
	    		}
	    		onCreateFlag = false;
        	}
        	reply = dbCon.getReplyList(WaypointID);
        	wayPointInfo = dbCon.getWayPointInfo(WaypointID);
    		CourceID = wayPointInfo.getId();
    		wayPointImg = dbCon.getWayPointImgList(WaypointID);
    		for(int i=0;i<wayPointImg.size();i++)
    		{
    			BitmapDownloaderTask task = new BitmapDownloaderTask();
    	        task.execute(wayPointImg.get(i).getSrc(),String.valueOf(i));
    		}
    		
    		return "1";
        }

        @Override
        // Once the image is downloaded, associates it to the imageView
        protected void onPostExecute(String a) {
            if (isCancelled()) {
            	a = null;
            }
            if(reply.size() != 0)
            {
            	courceReply.setText(reply.size()+" ǰ ϵǾ ֽϴ. \n \nڼ ÷ Ŭϼ.");
            }
            else
            {
            	courceReply.setText("ϵ ǰ ϴ.");
            }
            if(wayPointInfo.getComent() != null)
            {
            	comment.setText(wayPointInfo.getComent());
            }
            else
            {
            	comment.setText("  ּ");
            }
            adapter = new ViewAdapter();
    		albumList.setAdapter(adapter);
    		progress.setVisibility(View.GONE);
    		prevBtn.setClickable(true);
			nextBtn.setClickable(true);
        }
    } 
    class BitmapDownloaderTask extends AsyncTask<String, Void, Bitmap> 
    {
        
        @Override
        // Actual download method, run in the task thread
        protected Bitmap doInBackground(String... params) {
             // params comes from the execute() call: params[0] is the url.
        	InputStream bis;
			try {
				bis = new java.net.URL(params[0]).openStream();
			    Bitmap bm = BitmapFactory.decodeStream(new FlushedInputStream(bis));
			    wayPointImg.get(Integer.parseInt(params[1])).setMyBitmap(bm);
				bis.close();
				return bm;
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				Log.e("DownLoad Error","myAlbumView");
				
			}
			return null;
        }

        @Override
        // Once the image is downloaded, associates it to the imageView
        protected void onPostExecute(Bitmap bitmap) {
        	if(bitmap != null)
        	{ 
        		adapter.notifyDataSetChanged();
        	}
        }

    } 
    
}



