package PlayTravel.Activity;

import java.io.FilterInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.lang.ref.WeakReference;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;

import PlayTravel.Data.WayPoint;
import PlayTravel.Database.DB;
import PlayTravel.Map.Marker;
import PlayTravel.Map.NearMapOverlay;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.drawable.Drawable;
import android.location.Address;
import android.location.Criteria;
import android.location.Geocoder;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.CompoundButton.OnCheckedChangeListener;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.OverlayItem;

public class NearMapView extends MapActivity implements OnClickListener,OnCheckedChangeListener{
	private Intent intent;
	private MapView mapView;
	private MapController mc;
	private DB dbCon;
	private ArrayList<WayPoint> list;
	private ArrayList<WayPoint> catlist;
	private GeoPoint point;
	private Location location;
    private double lat;
    private double lng;
	Drawable drawable;
	NearMapDescription description;
	NearMapOverlay itemizedoverlay;
	NearMapOverlay itemizedoverlay2;
	private OverlayItem item;
	private LocationManager locationManager;
	private boolean gpsState;
	private boolean networkState;
	Handler mHandler;
	private int i;
	private ProgressDialog progress;
	private BitmapDownloaderTask task;
	
	private LinearLayout optionLayout;
	private CheckBox check[] = new CheckBox[10];
	private LinearLayout layout;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.nearmapview);
	
		findViewById(R.id.nearmapview_home).setOnClickListener(this);
		optionLayout = (LinearLayout)findViewById(R.id.option_layout);
		optionLayout.setOnClickListener(this);
		findViewById(R.id.option_btn).setOnClickListener(this);
		findViewById(R.id.ok_btn).setOnClickListener(this);
		layout = (LinearLayout)findViewById(R.id.mapdescription);
		
		check[0] = (CheckBox)findViewById(R.id.check0);
		check[0].setOnCheckedChangeListener(this);
		check[1] = (CheckBox)findViewById(R.id.check1);
		check[1].setOnCheckedChangeListener(this);
		check[2] = (CheckBox)findViewById(R.id.check2);
		check[2].setOnCheckedChangeListener(this);
		check[3] = (CheckBox)findViewById(R.id.check3);
		check[3].setOnCheckedChangeListener(this);
		check[4] = (CheckBox)findViewById(R.id.check4);
		check[4].setOnCheckedChangeListener(this);
		check[5] = (CheckBox)findViewById(R.id.check5);
		check[5].setOnCheckedChangeListener(this);
		check[6] = (CheckBox)findViewById(R.id.check6);
		check[6].setOnCheckedChangeListener(this);
		check[7] = (CheckBox)findViewById(R.id.check7);
		check[7].setOnCheckedChangeListener(this);
		check[8] = (CheckBox)findViewById(R.id.check8);
		check[8].setOnCheckedChangeListener(this);
		check[9] = (CheckBox)findViewById(R.id.check9);
		check[9].setOnCheckedChangeListener(this);
		
		for(int i=0; i<10; i++){
			check[i].setChecked(true);
		}
		
		mapView = (MapView) findViewById(R.id.mapview); 
        mapView.setBuiltInZoomControls(true);        
        mc=mapView.getController();      
        
        dbCon = new DB();
        list = new ArrayList<WayPoint>();
        catlist = new ArrayList<WayPoint>(); 
        
        locationManager = (LocationManager) getSystemService(LOCATION_SERVICE);
        
        gpsState = locationManager.isProviderEnabled(LocationManager.GPS_PROVIDER);
        networkState = locationManager.isProviderEnabled(LocationManager.NETWORK_PROVIDER);
        
        i=0;
        mHandler = new Handler();

		if(!gpsState && !networkState){
			createGpsDisabledAlert();
		}
		if(gpsState || networkState){
			Criteria criteria = new Criteria();
			criteria.setAccuracy(Criteria.NO_REQUIREMENT);
			criteria.setPowerRequirement(Criteria.NO_REQUIREMENT);
			String provider = locationManager.getBestProvider(criteria, true);
			location = locationManager.getLastKnownLocation(provider);
			locationManager.requestLocationUpdates(provider, 10000, 0, locationListener);
			
			progress = ProgressDialog.show(NearMapView.this, "", "Loading...");
			mHandler.post(mTimeRunnable);
		}
	}
	
	// GPS Disabled Alert
	private void createGpsDisabledAlert() {
	    AlertDialog.Builder builder = new AlertDialog.Builder(this);
	    builder.setMessage(" ġ ľϷ Ʈũ GPS ʿմϴ.  ̵Ͻðڽϱ? ")
	            .setCancelable(false)
	            .setPositiveButton("Ȯ",
	                    new DialogInterface.OnClickListener() {
	                        public void onClick(DialogInterface dialog, int id) {
	                            showGpsOptions();
	                        }
	                        
	                })
	            .setNegativeButton("",
	                    new DialogInterface.OnClickListener() {
	                        public void onClick(DialogInterface dialog, int id) {
	                            dialog.cancel();
	                            if(!gpsState && !networkState){
	                        		finish();
	                        	}
	                        }
	                });
	    AlertDialog alert = builder.create();
	    alert.show();
	}
	
	// show GPS Options
	private void showGpsOptions() {
	    Intent gpsOptionsIntent = new Intent(android.provider.Settings.ACTION_LOCATION_SOURCE_SETTINGS);
	    startActivity(gpsOptionsIntent);
	    finish();
	}
	
	Runnable mTimeRunnable = new Runnable() {
    	public void run(){
    		if(++i > 10){
    			updateWithNewLocation(location);
    			Toast.makeText(NearMapView.this, "GPS Ǵ Ʈũȣ մϴ.", Toast.LENGTH_SHORT).show();
    			if(!gpsState || !networkState){
    				createGpsDisabledAlert();
    			}
    		}else{
    			mHandler.postDelayed(this, 1000);
    		}
    	}
    };
    
	@Override
	protected void onStop() {
		locationManager.removeUpdates(locationListener);
		super.onStop();
	}

	public void onClick(View v) {
		switch(v.getId())
		{
		case R.id.nearmapview_home:
			intent = new Intent(NearMapView.this,Main.class);
			startActivity(intent);
			finish();
			break;
		case R.id.option_btn:
			optionLayout.setVisibility(View.VISIBLE);
			mapView.setBuiltInZoomControls(false);  
			break;
		case R.id.ok_btn:
			
			//īװ ޾ƿ üũִ ׸ Ʈ ߰
			catlist.clear();
			Animation anim = AnimationUtils.loadAnimation(NearMapView.this, R.anim.slide_up);
			layout.startAnimation(anim);
			layout.setVisibility(View.GONE);
			
	    	for(int i=0; i< list.size(); i++){
	    		int catId = list.get(i).getCategoryID();
	    		if(check[catId].isChecked())
	    		{
	    			catlist.add(list.get(i));
	    		}
	    	}
	    	
	    	//ġ ǥ
    		item = itemizedoverlay.getItem(0);
    		mapView.getOverlays().clear();
    		
    		itemizedoverlay2 = new NearMapOverlay(this, drawable, catlist, description);
    		itemizedoverlay2.addOverlay(item, drawable);
    		mc.animateTo(item.getPoint());
	        
	        //īװ ´ Ʈ Ŀ ߰
    		for(int i =0; i<catlist.size(); i++){
	        	point = new GeoPoint((int)(catlist.get(i).getX()*1E6),(int)(catlist.get(i).getY()*1E6));
	        	item = new OverlayItem(point, "", "");
	        	drawable = this.getResources().getDrawable(new Marker().getId(0, catlist.get(i).getCategoryID())); 
	        	item.setMarker(drawable);
	        	itemizedoverlay2.addOverlay(item, drawable);
	    	}

	    	mapView.getOverlays().add(itemizedoverlay2); 
	    	
	    	mapView.setBuiltInZoomControls(true);  
	    	optionLayout.setVisibility(View.GONE);
	    	break;
		}
	}
	
	@Override
	public void onCheckedChanged(CompoundButton v, boolean isChecked) {
		switch(v.getId())
		{
		case R.id.check0:
			if(isChecked){
				for(int i=1; i<10; i++){
					check[i].setChecked(true);
				}
			}
			else{
				for(int i=1; i<10; i++){
					check[i].setChecked(false);
				}	
			}
			break;
		case R.id.check1:
			if(!isChecked){
				check[0].setChecked(false);
			}
			break;
		case R.id.check2:
			if(!isChecked){
				check[0].setChecked(false);
			}
			break;
		case R.id.check3:
			if(!isChecked){
				check[0].setChecked(false);
			}
			break;
		case R.id.check4:
			if(!isChecked){
				check[0].setChecked(false);
			}
			break;
		case R.id.check5:
			if(!isChecked){
				check[0].setChecked(false);
			}
			break;
		case R.id.check6:
			if(!isChecked){
				check[0].setChecked(false);
			}
			break;
		case R.id.check7:
			if(!isChecked){
				check[0].setChecked(false);
			}
			break;
		case R.id.check8:
			if(!isChecked){
				check[0].setChecked(false);
			}
			break;
		case R.id.check9:
			if(!isChecked){
				check[0].setChecked(false);
			}
			break;
		}
	}
	
	@Override
	protected boolean isRouteDisplayed() {
		// TODO Auto-generated method stub
		return false;
	}
	
private final LocationListener locationListener = new LocationListener() {
		@Override
		public void onStatusChanged(String provider, int status, Bundle extras) {
		}
		
		@Override
		public void onProviderEnabled(String provider) {
		}
		
		@Override
		public void onProviderDisabled(String provider) {
			updateWithNewLocation(null);
		}
		
		@Override
		public void onLocationChanged(Location location) {
			updateWithNewLocation(location);		
		}
	};
	
	private double[] updateWithNewLocation(Location location)
	{
		progress.dismiss();
    	mHandler.removeCallbacks(mTimeRunnable);
    	locationManager.removeUpdates(locationListener);
    	
		double[] loca = new double[2];
		if(location !=null)
		{
			lat = location.getLatitude();
			lng = location.getLongitude();
			loca[0] = lat;
			loca[1] = lng;
		}
		else
		{	
			loca[0] = 37.466044;
			loca[1] = 126.959804;
		}		
		try{
			Geocoder gc = new Geocoder(this);
			List<Address> address = gc.getFromLocation(loca[0], loca[1], 1);
			String local = address.get(0).getLocality();
			
			if(local == null){
				local = "Ư";
			}
			list = dbCon.getWayPointListWithLocalName(local);
			catlist = dbCon.getWayPointListWithLocalName(local);;
			
			// ġ 
			drawable = this.getResources().getDrawable(R.drawable.icon_me);
	        description = new NearMapDescription();
	        itemizedoverlay = new NearMapOverlay(this, drawable, list, description);
	        point = new GeoPoint((int)(loca[0]*1E6),(int)(loca[1]*1E6));
	        item = new OverlayItem(point, "", "");
	        item.setMarker(drawable);
	        itemizedoverlay.addOverlay(item, drawable);
	             
	        mc.animateTo(point);
	        mc.setZoom(14);
	        
	        //Ʈ ִ Ŀ ߰
	    	for(int i=0; i< list.size(); i++){
	        	point = new GeoPoint((int)(list.get(i).getX()*1E6),(int)(list.get(i).getY()*1E6));
	        	item = new OverlayItem(point, "", "");
	        	drawable = this.getResources().getDrawable(new Marker().getId(0, list.get(i).getCategoryID())); 
	        	item.setMarker(drawable);
	        	itemizedoverlay.addOverlay(item, drawable);
	    	}
	    	mapView.getOverlays().add(itemizedoverlay); 
	    	
		}catch(Exception e){
			
		}
		
		return loca;
	}
	
	public class NearMapDescription{
		ImageView image = (ImageView)findViewById(R.id.photo);
		TextView albumtitle = (TextView)findViewById(R.id.albumtitle);
		TextView address = (TextView)findViewById(R.id.address);
		TextView category = (TextView)findViewById(R.id.category);
		TextView dateView = (TextView)findViewById(R.id.date);
		ImageButton btn_detail = (ImageButton)findViewById(R.id.btn_detail);
		
		//TODO  .  ߰ . ڼ   ٹ ҷð̳ Ѱ ڽ ҷð̳ 
		public void setDescription(final int index){
			final int albumId = catlist.get(index).getAlbumID();
			albumtitle.setText(dbCon.getAlbumInfo(albumId).getName());
			address.setText(catlist.get(index).getAdress());
			int catId = catlist.get(index).getCategoryID();
			category.setText(dbCon.getCategoryInfo(catId).getName());
			dateView.setText(catlist.get(index).getWaydate());
			btn_detail.setOnClickListener(new OnClickListener() {
				
				@Override
				public void onClick(View v) {
					intent = new Intent(NearMapView.this, OtherAlbumView.class);
					intent.putExtra("WaypointID", catlist.get(index).getId());
					intent.putExtra("AlbumID", albumId);
					startActivity(intent);
				}
			});
			
			if(task != null){
				task.cancel(true);
			}
			task = new BitmapDownloaderTask(image);
			task.execute(index);
			
			setVisible();
		}
		
		public void setVisible(){
			if(layout.getVisibility() == View.GONE){
				Animation anim = AnimationUtils.loadAnimation(NearMapView.this, R.anim.slide_down);
				layout.startAnimation(anim);
				layout.setVisibility(View.VISIBLE);
			}
			layout.setOnClickListener(new OnClickListener() {
				@Override
				public void onClick(View v) {
					setInvisible();
				}
			});
		}
		public void setInvisible(){
			Animation anim = AnimationUtils.loadAnimation(NearMapView.this, R.anim.slide_up);
			layout.startAnimation(anim);
			layout.setVisibility(View.GONE);
		}
	}
	
	public class PatchInputStream extends FilterInputStream {
		public PatchInputStream(InputStream in) {
			super(in);
		}

		public long skip(long n) throws IOException {
			long m = 0L;
			while (m < n) {
				long _m = in.skip(n - m);
				if (_m == 0L)
					break;
				m += _m;
			}
			return m;
		}
	}
	
	 class BitmapDownloaderTask extends AsyncTask<Integer, Void, Bitmap> 
	    {
	        private final WeakReference<ImageView> imageViewReference;

	        public BitmapDownloaderTask(ImageView imageView) {
	            imageViewReference = new WeakReference<ImageView>(imageView);
	        }

	        @Override
	        // Actual download method, run in the task thread
	        protected Bitmap doInBackground(Integer... params) {
	             // params comes from the execute() call: params[0] is the url.
	        	
	        	// image URL ڵؼ imageList ־ֱ
				int waypointId = catlist.get(params[0]).getId();
				String urlSrc = dbCon.getWayPointImgList(waypointId).get(0).getSrc();
	        	try {
					URL url = new URL(urlSrc);
					InputStream is = url.openStream();
					BitmapFactory.Options options = new BitmapFactory.Options();
					options.inSampleSize = 2;
					Bitmap bitmapImage = BitmapFactory.decodeStream(new PatchInputStream(is), null, options);
					is.close();
					return bitmapImage;
				} catch (IOException e) {
				}

				return null;
	        }

	        @Override
	        // Once the image is downloaded, associates it to the imageView
	        protected void onPostExecute(Bitmap bitmap) {
	            if (isCancelled()) {
	                bitmap = null;
	            }

	            if (imageViewReference != null) {
	                ImageView imageView = imageViewReference.get();
	                if (imageView != null) {
	                    imageView.setImageBitmap(bitmap);
	                    imageView.setScaleType(ImageView.ScaleType.FIT_XY);
	                }
	            }
	        }

	    }

}
