package PlayTravel.Activity;

import java.io.FilterInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;

import PlayTravel.Data.Album;
import PlayTravel.Data.Local;
import PlayTravel.Data.Theme;
import PlayTravel.Database.DB;
import android.app.ListActivity;
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.AbsListView;
import android.widget.AbsListView.OnScrollListener;
import android.widget.BaseAdapter;
import android.widget.Gallery.LayoutParams;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.ProgressBar;
import android.widget.RatingBar;
import android.widget.TextView;
import android.widget.Toast;

public class OtherAlbumList extends ListActivity implements OnClickListener{
	private Intent intent;
	private Intent receivedIntent;
	private ListView list;
	private AlbumAdapter adapter;
	private DB dbCon;
	private ArrayList<Album> otherAlbumList;
	private int pageNum;
	private int pageCount;
	private int totalPage;
	private ProgressBar progress;
	private ArrayList<BitmapDownloaderTask> task;
	private ImageButton location;
	private ImageButton theme;
	private TextView spinner_locationText;
	private TextView spinner_themeText;
	private boolean LocationaniFlag =false;
	private boolean ThemeaniFlag =false;
	private LinearLayout otheralbum_catetheme;
	private LinearLayout otheralbum_catelocation;
	private Integer ThemeID;
	private String ThemeName;
	private String LocationID;
	private String LocationName;
	private boolean ThreadFlag= false;

	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		setContentView(R.layout.otheralbumlist);
		receivedIntent = getIntent();
		ThemeID = receivedIntent.getIntExtra("themecateID", -1);
		ThemeName = receivedIntent.getStringExtra("themecateName");
		LocationID = receivedIntent.getStringExtra("locationcateID");
		LocationName = receivedIntent.getStringExtra("locationcateName");
		dbCon = new DB();
		otherAlbumList = new ArrayList<Album>();
		task = new ArrayList<BitmapDownloaderTask>();
		pageNum = 1;
		pageCount = 10;
		otheralbum_catetheme = (LinearLayout)findViewById(R.id.otheralbum_catetheme);
		otheralbum_catelocation = (LinearLayout)findViewById(R.id.otheralbum_catelocation);
		spinner_locationText =(TextView)findViewById(R.id.spinner_locationText);
		spinner_themeText =(TextView)findViewById(R.id.spinner_themeText);
		progress = (ProgressBar)findViewById(R.id.otherAlbumList_progress);
		location =(ImageButton)findViewById(R.id.spinner_location);
		theme =(ImageButton)findViewById(R.id.spinner_theme);
		location.setOnClickListener(this);
		theme.setOnClickListener(this);
		findViewById(R.id.otheralbumlist_home).setOnClickListener(this);
		list = getListView();
		adapter = new AlbumAdapter();
		spinner_locationText.setText(LocationName);
		spinner_themeText.setText(ThemeName);
		UITast task = new UITast();
		task.execute();
 		list.setOnScrollListener(new OnScrollListener() {
			
			@Override
			public void onScrollStateChanged(AbsListView view, int scrollState) {
				// TODO Auto-generated method stub
			}
			
			@Override
			public void onScroll(AbsListView view, int firstVisibleItem,int visibleItemCount, int totalItemCount) {
				// TODO Auto-generated method stub
					if((firstVisibleItem+visibleItemCount)==totalItemCount && totalItemCount != 0 && otherAlbumList.size() %10 == 0 && ThreadFlag == false)
					{
						ThreadFlag = true;
						progress.setVisibility(View.VISIBLE);
						pageNum++;
						UITast task = new UITast();
						task.execute();
					}
				}
		});
        
	}
	@Override
	protected void onRestart() {
		// TODO Auto-generated method stub
		super.onRestart();
	}
	@Override
	protected void onStart() {
		// TODO Auto-generated method stub
		super.onStart();
	}
	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		super.onResume();
	}
	@Override
	protected void onPause() {
		// TODO Auto-generated method stub
		super.onPause();
	}

	@Override
	protected void onStop() {
		// TODO Auto-generated method stub
		super.onStop();
	}
	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		super.onDestroy();
		for(int i=0;i<task.size();i++)
		{
			if(task.get(i) != null && task.get(i).getStatus()!=AsyncTask.Status.FINISHED)
			{
				task.get(i).cancel(true);
			}
		}
	}
	@Override
	public void onClick(View v) {
		// TODO Auto-generated method stub
		switch(v.getId())
		{
		case R.id.otheralbumlist_home:
			intent = new Intent(OtherAlbumList.this,Main.class);
			startActivity(intent);
			finish();
			break;
		case R.id.spinner_location:
			if(LocationaniFlag == false)
			{
				otheralbum_catelocation.setVisibility(View.VISIBLE);
				LocationaniFlag = true;
			}
			else
			{
				otheralbum_catelocation.setVisibility(View.INVISIBLE);
				LocationaniFlag = false;
			}
			break;
		case R.id.spinner_theme:
			if(ThemeaniFlag == false)
			{
				otheralbum_catetheme.setVisibility(View.VISIBLE);
				ThemeaniFlag = true;
			}
			else
			{
				otheralbum_catetheme.setVisibility(View.INVISIBLE);
				ThemeaniFlag = false;
			}
			break;
		}
		
	}
	class AlbumAdapter extends BaseAdapter
	{

		
		@Override
		public int getCount() {
			// TODO Auto-generated method stub
			return otherAlbumList.size();
		}

		@Override
		public Object getItem(int position) {
			// TODO Auto-generated method stub
			return null;
		}

		@Override
		public long getItemId(int position) {
			// TODO Auto-generated method stub
			return 0;
		}

		@Override
		public View getView(int position, View convertView, ViewGroup parent) {
			ViewHolder holder;
			View v = convertView;
			if(v ==null)
			{
				LayoutInflater vi = (LayoutInflater)getSystemService(Context.LAYOUT_INFLATER_SERVICE);
				v = vi.inflate(R.layout.otheralbumlist_row, null);
				holder = new ViewHolder();
				holder.imageID = (ImageView)v.findViewById(R.id.otheralbumlistimg);
				holder.themeID = (TextView)v.findViewById(R.id.otherthemeID);
				holder.nameID = (TextView)v.findViewById(R.id.othernameID);
				holder.createDate = (TextView)v.findViewById(R.id.othercreateDate);
				holder.rating = (RatingBar)v.findViewById(R.id.otheralbumlistrating);
				v.setTag(holder);
			}
			else
			{
				holder = (ViewHolder)v.getTag();
			}
			
			
			if(otherAlbumList.get(position).getImgBitmap() != null)
			{
				holder.imageID.setImageBitmap(otherAlbumList.get(position).getImgBitmap());
				holder.imageID.setScaleType(ImageView.ScaleType.FIT_XY);
			}
			else
			{
				holder.imageID.setImageResource(R.drawable.blank_image);
				holder.imageID.setScaleType(ImageView.ScaleType.FIT_XY);
			}
			final int pos = position;
			holder.rating.setRating((float)otherAlbumList.get(position).getGrade());
			holder.themeID.setText(otherAlbumList.get(position).getThemeName().toString());
			holder.nameID.setText(otherAlbumList.get(position).getName());
			holder.createDate.setText(otherAlbumList.get(position).getCreateDate().toString().replace("2010", "10"));
			v.setOnClickListener(new OnClickListener() {
				
				@Override
				public void onClick(View v) {
					// TODO Auto-generated method stub
					intent = new Intent(OtherAlbumList.this,AlbumMapView.class);
					intent.putExtra("AlbumID",otherAlbumList.get(pos).getId());
					intent.putExtra("AlbumFlag",false);
					intent.putExtra("isMyAlbum", otherAlbumList.get(pos).getMyFlag());
					startActivity(intent);
					
				}
			});
			return v;
		}
	}
	static class ViewHolder
	{	
		ImageView imageID;
		TextView themeID;
		TextView regionID;
		TextView nameID;
		TextView createDate;
		RatingBar rating;
		////////////\
		LinearLayout spinnerLinear;
		TextView spinnerText;
	}	
	class FlushedInputStream extends FilterInputStream {
	    public FlushedInputStream(InputStream inputStream) {
	        super(inputStream);
	    }

	    @Override
	    public long skip(long n) throws IOException {
	        long totalBytesSkipped = 0L;
	        while (totalBytesSkipped < n) {
	            long bytesSkipped = in.skip(n - totalBytesSkipped);
	            if (bytesSkipped == 0L) {
	                  int bite = read();
	                  if (bite < 0) {
	                      break;  // we reached EOF
	                  } else {
	                      bytesSkipped = 1; // we read one byte
	                  }
	           }
	            totalBytesSkipped += bytesSkipped;
	        }
	        return totalBytesSkipped;
	    }
	}
	class UITast extends AsyncTask<String,Void, ArrayList<Album>> 
    {
		private ArrayList<Theme> cateTheme;
		private ArrayList<Local> cateLocation;
        @Override
        protected ArrayList<Album> doInBackground(String... str) {
        	
        	ArrayList<Album> temp = dbCon.getAlbumList(2,pageNum,pageCount,LocationID,ThemeID);
        	otherAlbumList.addAll(new ArrayList<Album>(temp));
        	if(otherAlbumList.size() ==0)
        	{
        		
        		cancel(true);
        		finish();
        	}
    		if(pageNum == 1)
    		{
    			totalPage = otherAlbumList.get(0).getTotalPageCount();
    		}
        	cateLocation = dbCon.getLocalList();
        	cateTheme = dbCon.getThemeList();
        	for(int i=0;i<temp.size();i++)
    		{
        		task.add(new BitmapDownloaderTask());
        		Integer aa = (pageNum-1)*10+i;
        		
    	        task.get(aa).execute(otherAlbumList.get(aa).getImgSrc(),String.valueOf(aa));
    	        
    		}
    		return otherAlbumList;
        }
        
        @Override
		protected void onCancelled() {
			// TODO Auto-generated method stub
			super.onCancelled();
		}

		@Override
        // Once the image is downloaded, associates it to the imageView
        protected void onPostExecute(ArrayList<Album> otherAlbumList) {
	        	TextView text1 = new TextView(OtherAlbumList.this);
	        	text1.setBackgroundResource(R.drawable.spinner_row);
	        	text1.setText("ü ");
	        	text1.setTextColor(Color.GRAY);
	        	text1.setGravity(Gravity.CENTER);
	        	text1.setOnClickListener(new OnClickListener() {
					
					@Override
					public void onClick(View v) {
						// TODO Auto-generated method stub
						spinner_locationText.setText("ü");
						spinner_locationText.setVisibility(View.GONE);
						LocationaniFlag = false;
						intent = new Intent(OtherAlbumList.this,OtherAlbumList.class);
						intent.putExtra("themecateID",ThemeID);
						intent.putExtra("themecateName",ThemeName);
						intent.putExtra("locationcateName","ü");
						intent.putExtra("locationcateID","0");
						startActivity(intent);
						finish();
						
					}
				});
	        	TextView text2 = new TextView(OtherAlbumList.this);
	        	text2.setBackgroundResource(R.drawable.spinner_row);
	        	text2.setText("ü ");
	        	text2.setTextColor(Color.GRAY);
	        	text2.setGravity(Gravity.CENTER);
	        	text2.setOnClickListener(new OnClickListener() {
					
					@Override
					public void onClick(View v) {
						// TODO Auto-generated method stub
						spinner_themeText.setText("ü");
						spinner_themeText.setVisibility(View.GONE);
						ThemeaniFlag = false;
						intent = new Intent(OtherAlbumList.this,OtherAlbumList.class);
						intent.putExtra("themecateID",0);
						intent.putExtra("themecateName","ü");
						intent.putExtra("locationcateName",LocationName);
						intent.putExtra("locationcateID",LocationID);
						startActivity(intent);
						finish();
						
					}
				});
	        	if(pageNum ==1)
	        	{
			        	otheralbum_catelocation.addView(text1, 0, new LayoutParams(LayoutParams.WRAP_CONTENT, android.view.ViewGroup.LayoutParams.WRAP_CONTENT));
			        	otheralbum_catetheme.addView(text2, 0, new LayoutParams(LayoutParams.WRAP_CONTENT, android.view.ViewGroup.LayoutParams.WRAP_CONTENT));
	        	}
	            for(int i=0;i<cateLocation.size();i++)
	            {
	            	final int pos =i;
	            	TextView text = new TextView(OtherAlbumList.this);
	            	text.setBackgroundResource(R.drawable.spinner_row);
	            	text.setText(cateLocation.get(i).getName());
	            	text.setTextColor(Color.GRAY);
	            	text.setGravity(Gravity.CENTER);
	            	text.setOnClickListener(new OnClickListener() {
						
						@Override
						public void onClick(View v) {
							// TODO Auto-generated method stub
							progress.setVisibility(View.VISIBLE);
							ArrayList<Album> temp = dbCon.getAlbumList(2,1,pageCount,cateLocation.get(pos).getName(),ThemeID);
							progress.setVisibility(View.GONE);
							if(temp.size() != 0)
							{
								
								spinner_locationText.setText(cateLocation.get(pos).getName());
								otheralbum_catelocation.setVisibility(View.GONE);
								LocationaniFlag = false;
								intent = new Intent(OtherAlbumList.this,OtherAlbumList.class);
								intent.putExtra("themecateID",ThemeID);
								intent.putExtra("themecateName",ThemeName);
								intent.putExtra("locationcateID",cateLocation.get(pos).getName());
								intent.putExtra("locationcateName",cateLocation.get(pos).getName());
								startActivity(intent);
								finish();
							}
							else
							{
								Toast.makeText(OtherAlbumList.this, "ٹ ϵǾ ʽϴ.", Toast.LENGTH_SHORT).show();
								otheralbum_catelocation.setVisibility(View.GONE);
								
							}
						}
					});
	            	if(pageNum ==1)
		        	{
	            		otheralbum_catelocation.addView(text, i+1, new LayoutParams(LayoutParams.WRAP_CONTENT, android.view.ViewGroup.LayoutParams.WRAP_CONTENT));
		        	}
	            }
	            for(int i=0;i<cateTheme.size();i++)
	            {
	            	final int pos =i;
	            	TextView text = new TextView(OtherAlbumList.this);
	            	text.setBackgroundResource(R.drawable.spinner_row);
	            	text.setText(cateTheme.get(i).getName());
	            	text.setTextColor(Color.GRAY);
	            	text.setGravity(Gravity.CENTER);
	            	text.setOnClickListener(new OnClickListener() {
						
						@Override
						public void onClick(View v) {
							// TODO Auto-generated method stub
							progress.setVisibility(View.VISIBLE);
							ArrayList<Album> temp = dbCon.getAlbumList(2,1,pageCount,LocationID,cateTheme.get(pos).getId());
							progress.setVisibility(View.GONE);
							if(temp.size() != 0)
							{
								spinner_themeText.setText(cateTheme.get(pos).getName());
								otheralbum_catetheme.setVisibility(View.GONE);
								ThemeaniFlag = false;
								intent = new Intent(OtherAlbumList.this,OtherAlbumList.class);
								intent.putExtra("locationcateName",LocationName);
								intent.putExtra("locationcateID",LocationID);
								intent.putExtra("themecateID",cateTheme.get(pos).getId());
								intent.putExtra("themecateName",cateTheme.get(pos).getName());
								startActivity(intent);
								finish();
							}
							else
							{
								Toast.makeText(OtherAlbumList.this, "ٹ ϵǾ ʽϴ.", Toast.LENGTH_SHORT).show();
								otheralbum_catetheme.setVisibility(View.GONE);
							}
						}
					});
	            	if(pageNum ==1)
		        	{
	            		otheralbum_catetheme.addView(text, i+1, new LayoutParams(LayoutParams.WRAP_CONTENT, android.view.ViewGroup.LayoutParams.WRAP_CONTENT));
		        	}
	            }
        	if(pageNum == 1)
        	{
	    		adapter = new AlbumAdapter();
	    		list.setAdapter(adapter);
	    		progress.setVisibility(View.GONE);
        	}
        	else
        	{
        		adapter.notifyDataSetChanged();
        		progress.setVisibility(View.GONE);
        	}
        	ThreadFlag = false;
        	
        }
    } 
	class BitmapDownloaderTask extends AsyncTask<String, Void, String> 
    {

        @Override
        // Actual download method, run in the task thread
        protected String doInBackground(String... params) {
             // params comes from the execute() call: params[0] is the url.
        	InputStream bis;
        	String Flag;
			try {
				bis = new java.net.URL(params[0]).openStream();
				BitmapFactory.Options options = new BitmapFactory.Options();
			    options.inSampleSize = 4;
			    Bitmap bm = BitmapFactory.decodeStream(new FlushedInputStream(bis),null,options);
			    otherAlbumList.get(Integer.parseInt(params[1])).setImgBitmap(bm);
				bis.close();
				return "1";
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();

			}
			return null;
        }

        @Override
        // Once the image is downloaded, associates it to the imageView
        protected void onPostExecute(String Flag) {
            if(Flag != null)
            {
            	adapter.notifyDataSetChanged();
            }
        }

    } 
}
