package PlayTravel.Activity;

import java.io.FilterInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.util.ArrayList;

import PlayTravel.Data.Reply;
import PlayTravel.Data.WayPoint;
import PlayTravel.Data.WayPointImg;
import PlayTravel.Database.DB;
import android.app.ListActivity;
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.ProgressBar;
import android.widget.TextView;
import android.widget.Toast;


public class OtherAlbumView extends ListActivity implements OnClickListener{
	private Intent receivedIntent;
	private Intent intent;
	private ListView albumList;
	private	 ViewAdapter adapter;
	private DB dbCon;
	private int CourceID;
	private TextView comment;
	private TextView courceReply;
	private int WaypointID;
	private int AlbumID;
	private ArrayList<WayPoint> wayPoint;
	private	int index;
	ArrayList<WayPointImg> wayPointImg;
	private boolean onCreateFlag;
	private int Count;
//	private ArrayList<ImgPosition> image;
	private ArrayList<Reply> reply ;
	private WayPoint wayPointInfo;
	private ImageButton prevBtn;
	private ImageButton nextBtn;
	private ProgressBar progress;
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		setContentView(R.layout.otheralbumview);
		onCreateFlag =true;
		courceReply = (TextView)findViewById(R.id.otherreplytext);
		courceReply.setOnClickListener(this);
		findViewById(R.id.otheralbumview_home).setOnClickListener(this);
		prevBtn = (ImageButton)findViewById(R.id.otherbtncourceprev);
		prevBtn.setOnClickListener(this);
		nextBtn = (ImageButton)findViewById(R.id.otherbtncourcenext);
		nextBtn.setOnClickListener(this);
		findViewById(R.id.otherbtnmapview).setOnClickListener(this);
		findViewById(R.id.otherbtnreview).setOnClickListener(this);
		progress= (ProgressBar)findViewById(R.id.otheralbumview_progress);
		comment = (TextView)findViewById(R.id.otheralbumview_comment);
		wayPoint = new ArrayList<WayPoint>();
		wayPointImg = new ArrayList<WayPointImg>();
		dbCon = new DB();
		
		receivedIntent = getIntent();
		WaypointID = receivedIntent.getIntExtra("WaypointID", -1);
		AlbumID = receivedIntent.getIntExtra("AlbumID", -1);
	}
	@Override
	protected void onRestart() {
		// TODO Auto-generated method stub
		super.onRestart();
	}
	@Override
	protected void onStart() {
		// TODO Auto-generated method stub
		super.onStart();
	}
	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		super.onResume();
		albumList = null;
		albumList = getListView();
		comment.setText("");
		UIloaderTask task = new UIloaderTask();
        task.execute();
        progress.setVisibility(View.GONE);
	}
	@Override
	protected void onPause() {
		// TODO Auto-generated method stub
		super.onPause();
	}

	@Override
	protected void onStop() {
		// TODO Auto-generated method stub
		super.onStop();
	}
	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		super.onDestroy();
	}
	@Override
	public void onClick(View v) {
		// TODO Auto-generated method stub
		switch(v.getId())
		{
		case R.id.otheralbumview_home:
			intent = new Intent(OtherAlbumView.this,Main.class);
			startActivity(intent);
			finish();
			break;
		case R.id.otherbtncourceprev:
			if(index != 0)
			{
				progress.setVisibility(View.VISIBLE);
				index--;
				WaypointID = wayPoint.get(index).getId();
				prevBtn.setClickable(false);
				nextBtn.setClickable(false);
				onResume();
			}
			else
			{
				Toast.makeText(this, "ù°ڽԴϴ", 500).show();
			}
			break;
			
		case R.id.otherbtncourcenext:
			if(index != wayPoint.size()-1)
			{
				progress.setVisibility(View.VISIBLE);
				index++;
				WaypointID = wayPoint.get(index).getId();
				prevBtn.setClickable(false);
				nextBtn.setClickable(false);
				onResume();	
			}
			else
			{
				Toast.makeText(this, "ڽԴϴ", 500).show();
			}
			break;
		case R.id.otherbtnreview:
			intent = new Intent(OtherAlbumView.this,WriteReview.class);
			Log.d("review","go : " + WaypointID);
			intent.putExtra("WaypointID", WaypointID);
			startActivity(intent);
			break;
		case R.id.otherbtnmapview:
			intent = new Intent(OtherAlbumView.this,AlbumMapView.class);
			intent.putExtra("AlbumID",AlbumID);
			intent.putExtra("WaypointID",WaypointID);
			intent.putExtra("AlbumFlag", false);
			startActivity(intent);
			break;
		case R.id.otherreplytext :
			intent =  new Intent(OtherAlbumView.this,ReviewList.class);
			intent.putExtra("WaypointID", WaypointID);
			intent.putExtra("isMyAlbum", false);
			startActivity(intent);
			
		}
		
	}
	class ViewAdapter extends ArrayAdapter<WayPointImg>
	{

		private ArrayList<WayPointImg> items;


		public ViewAdapter(Context context, int textViewResourceId,ArrayList<WayPointImg> objects) {
			super(context, textViewResourceId,objects);
			// TODO Auto-generated constructor stub
			items = objects;
		}

		

//		@Override
//		public int getCount() {
//			// TODO Auto-generated method stub
//			return items.size();
//		}

		

		@Override
		public View getView(int position, View convertView, ViewGroup parent) {
			ViewHolder holder;
			View v = convertView;
			if(v ==null)
			{
				LayoutInflater vi = (LayoutInflater)getSystemService(Context.LAYOUT_INFLATER_SERVICE);
				v = vi.inflate(R.layout.otheralbumviewrow, null);
				holder = new ViewHolder();
				holder.courceImg = (ImageView)v.findViewById(R.id.othercourceImg);
				v.setTag(holder);
				
			}
			else
			{
				holder = (ViewHolder)v.getTag();
			}
			if(wayPointImg.get(position).getMyBitmap() != null)
			{
					holder.courceImg.setImageBitmap(wayPointImg.get(position).getMyBitmap());
					holder.courceImg.setScaleType(ImageView.ScaleType.FIT_XY);
			}
			else
			{
				holder.courceImg.setImageResource(R.drawable.blank_image);
				holder.courceImg.setScaleType(ImageView.ScaleType.FIT_XY);
			}
			return v;
		}
		
	}
	static class ViewHolder
	{	
		ImageView courceImg;			
	}	
	class FlushedInputStream extends FilterInputStream {
	    public FlushedInputStream(InputStream inputStream) {
	        super(inputStream);
	    }

	    @Override
	    public long skip(long n) throws IOException {
	        long totalBytesSkipped = 0L;
	        while (totalBytesSkipped < n) {
	            long bytesSkipped = in.skip(n - totalBytesSkipped);
	            if (bytesSkipped == 0L) {
	                  int bite = read();
	                  if (bite < 0) {
	                      break;  // we reached EOF
	                  } else {
	                      bytesSkipped = 1; // we read one byte
	                  }
	           }
	            totalBytesSkipped += bytesSkipped;
	        }
	        return totalBytesSkipped;
	    }
	}
                                                                                     // Param, Progress, Result
    class UIloaderTask extends AsyncTask<String,Void, String> 
    {
        @Override
        // Actual download method, run in the task thread
        protected String doInBackground(String... str) {
             // params comes from the execute() call: params[0] is the url.
        	if(onCreateFlag == true)
        	{
	        	wayPoint = dbCon.getWayPointList(AlbumID);
	        	
	    		for(int i=0;i<wayPoint.size();i++)
	    		{
	    			if(wayPoint.get(i).getId() == WaypointID)
	    			{
	    				index =i;
	    				break;
	    			}
	    		}
	    		onCreateFlag = false;
        	}
        	reply = dbCon.getReplyList(WaypointID);
        	wayPointInfo = dbCon.getWayPointInfo(WaypointID);
    		CourceID = wayPointInfo.getId();
    		wayPointImg = dbCon.getWayPointImgList(WaypointID);
    		for(int i=0;i<wayPointImg.size();i++)
    		{
    			BitmapDownloaderTask task = new BitmapDownloaderTask();
    	        task.execute(wayPointImg.get(i).getSrc(),String.valueOf(i));
    		}
    		return "1";
        }

        @Override
        // Once the image is downloaded, associates it to the imageView
        protected void onPostExecute(String a) {
        	if(reply.size() != 0)
            {
            	courceReply.setText(reply.size()+" ǰ ϵǾ ֽϴ. \nڼ ÷ Ŭϼ.");
            }
            else
            {
            	courceReply.setText("ϵ ǰ ϴ.");
            }
            
            if(wayPointInfo.getComent() != null)
            {
            	comment.setText(wayPointInfo.getComent());
            }
            else
            {
            	comment.setText("ϵ  ϴ");
            }
            adapter = new ViewAdapter(OtherAlbumView.this, R.layout.myalbumviewrow,wayPointImg);
    		albumList.setAdapter(adapter);
    		prevBtn.setClickable(true);
			nextBtn.setClickable(true);
        }
    } 
    class BitmapDownloaderTask extends AsyncTask<String, Void, Bitmap> 
    {
        
        @Override
        // Actual download method, run in the task thread
        protected Bitmap doInBackground(String... params) {
             // params comes from the execute() call: params[0] is the url.
        	URL imageURL;
        	InputStream bis;
			try {
				bis = new java.net.URL(params[0]).openStream();
			    Bitmap bm = BitmapFactory.decodeStream(new FlushedInputStream(bis));
			    wayPointImg.get(Integer.parseInt(params[1])).setMyBitmap(bm);
				bis.close();
				return bm;
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
		
			}
			return null;
        }

        @Override
        // Once the image is downloaded, associates it to the imageView
        protected void onPostExecute(Bitmap bitmap) {
           if(bitmap != null)
           {
        	   adapter.notifyDataSetChanged();
           }
        }

    } 

}
