package PlayTravel.Activity;

import java.util.List;

import PlayTravel.Database.DB;
import android.app.PendingIntent;
import android.appwidget.AppWidgetManager;
import android.appwidget.AppWidgetProvider;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.location.Address;
import android.location.Criteria;
import android.location.Geocoder;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.widget.ProgressBar;
import android.widget.RemoteViews;
import android.widget.Toast;

public class PlayTravelAppWidgetProvider extends AppWidgetProvider {

	private static DB dbCon = new DB();
	Context thisContext;
	private Location location;
    private Geocoder gc;
    private String address_str;
    private String local_name;
    private LocationManager locationManager;
    private boolean gpsState;
    private boolean networkState;
    Handler mHandler;
    private int i;
	
	@Override
	public void onDeleted(Context context, int[] appWidgetIds) {
		super.onDeleted(context, appWidgetIds);
	}

	@Override
	public void onDisabled(Context context) {
		super.onDisabled(context);
	}

	@Override
	public void onEnabled(Context context) {
       		super.onEnabled(context);
	}

	@Override
	public void onReceive(Context context, Intent intent) {
		super.onReceive(context, intent);
		thisContext = context;
		
		if(intent.getAction().equals("playtravel.Click"))
		{
			gc = new Geocoder(context);
			locationManager = (LocationManager) context.getSystemService(context.LOCATION_SERVICE);
	        gpsState = locationManager.isProviderEnabled(LocationManager.GPS_PROVIDER);
	        networkState = locationManager.isProviderEnabled(LocationManager.NETWORK_PROVIDER);

	        i=0;
	        mHandler = new Handler();
	        
			if(!gpsState && !networkState){
				Toast.makeText(thisContext, "Ʈũ GPS Ȯ  ٽ õּ.", Toast.LENGTH_SHORT).show();
			}
			if(gpsState || networkState){
				Criteria criteria = new Criteria();
				criteria.setAccuracy(Criteria.NO_REQUIREMENT);
				criteria.setPowerRequirement(Criteria.NO_REQUIREMENT);
				String provider = locationManager.getBestProvider(criteria, true);
				location = locationManager.getLastKnownLocation(provider);
				locationManager.requestLocationUpdates(provider, 10000, 0, locationListener);
				
				mHandler.post(mTimeRunnable);
			}
		}
	}
	
	Runnable mTimeRunnable = new Runnable() {
    	public void run(){
    		if(++i > 10){
    			if(!gpsState || !networkState){
    				Toast.makeText(thisContext, "Ʈũ GPS Ȯ  ٽ õּ.", Toast.LENGTH_SHORT).show();
    			}else{
    				Toast.makeText(thisContext, "GPS Ǵ Ʈũȣ մϴ. ٽ õּ.", Toast.LENGTH_SHORT).show();
    			}
    			mHandler.removeCallbacks(mTimeRunnable);
    	    	locationManager.removeUpdates(locationListener);
    	    	
    		}else{
    			mHandler.postDelayed(this,600);
    		}
    	}
    };

	@Override
	public void onUpdate(Context context, AppWidgetManager appWidgetManager,
			int[] appWidgetIds) {
		
        final int N = appWidgetIds.length;
        
        for(int i=0;i<N;i++)
		{
			int[] appWidgetId = appWidgetIds;
			RemoteViews views = new RemoteViews(context.getPackageName(),R.layout.widget);
			Intent clickIntent=new Intent("playtravel.Click");
			PendingIntent pi = PendingIntent.getBroadcast(context, 0, clickIntent, 0);
			views.setOnClickPendingIntent(R.id.btn_click, pi);
			appWidgetManager.updateAppWidget(appWidgetId, views);
		}
      
		super.onUpdate(context, appWidgetManager, appWidgetIds);
	}
	
	
	private final LocationListener locationListener = new LocationListener() {
		
		@Override
		public void onStatusChanged(String provider, int status, Bundle extras) {
		}
		
		@Override
		public void onProviderEnabled(String provider) {
		}
		
		@Override
		public void onProviderDisabled(String provider) {
			updateWithNewLocation(null);
		}
		
		@Override
		public void onLocationChanged(Location location) {
			updateWithNewLocation(location);
		}
	};
	
	private double[] updateWithNewLocation(Location location)
	{
    	mHandler.removeCallbacks(mTimeRunnable);
    	locationManager.removeUpdates(locationListener);
    	
		double[] loca = new double[2];
		if(location !=null)
		{
			loca[0] = location.getLatitude();
			loca[1] = location.getLongitude();
		}
		else
		{	
			loca[0] = 37.466044;
			loca[1] = 126.959804;
		}
        
		try{
			List<Address> address = gc.getFromLocation(loca[0], loca[1], 1);
			address_str = address.get(0).getAddressLine(0);
			local_name = address.get(0).getLocality();
			
			int albumId = Integer.parseInt(dbCon.getLastAlbumID());
			if(albumId > 0){
				String res = dbCon.insertWayPointWidget(loca[0], loca[1], address_str, albumId, local_name);
				if(res.equals("ok")){
					Toast.makeText(thisContext, "ڽ ߰Ǿϴ.", Toast.LENGTH_SHORT).show();
				}
			}else{
				Toast.makeText(thisContext, "ϵ ٹ ϴ.", Toast.LENGTH_SHORT).show();
			}
			
		}catch(Exception e){
			e.printStackTrace();
		}
		
		return loca;
	}
}
