package PlayTravel.Activity;

import java.util.ArrayList;

import PlayTravel.Data.Reply;
import PlayTravel.Database.DB;
import android.app.ListActivity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.RatingBar;
import android.widget.TextView;

public class ReviewList extends ListActivity implements OnClickListener {
	private Intent intent;
	private Intent receiveIntent;
	private ListView list;
	private ListAdapter adapter;
	private DB dbCon;
	private int waypointID;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.reviewlist);
		dbCon = new DB();
		findViewById(R.id.reviewlist_home).setOnClickListener(this);
		findViewById(R.id.reviewwrite_btn).setOnClickListener(this);
		list = getListView();
	}

	@Override
	protected void onRestart() {
		// TODO Auto-generated method stub
		super.onRestart();
	}

	@Override
	protected void onStart() {
		super.onStart();
	}

	@Override
	protected void onResume() {
		//TODO getIntent waypointID ޾ƿ
		receiveIntent = getIntent();
		waypointID = receiveIntent.getIntExtra("WaypointID", -1);
		boolean isMyAlbum = receiveIntent.getBooleanExtra("isMyAlbum", true);
		
		//ٹ
		if(isMyAlbum){
			findViewById(R.id.reviewwrite_btn).setVisibility(View.GONE);
		}
		ArrayList<Reply> reviewList = dbCon.getReplyList(waypointID);
		adapter = new ListAdapter(this, R.layout.reviewlist_row, reviewList);
		list.setAdapter(adapter);
		super.onResume();

	}

	@Override
	protected void onPause() {
		// TODO Auto-generated method stub
		super.onPause();
	}

	@Override
	protected void onStop() {
		// TODO Auto-generated method stub
		super.onStop();
	}

	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		super.onDestroy();
	}

	@Override
	public void onClick(View v) {
		// TODO Auto-generated method stub
		switch (v.getId()) {
		case R.id.reviewlist_home:
			intent = new Intent(ReviewList.this, Main.class);
			startActivity(intent);
			finish();
			break;
		case R.id.reviewwrite_btn:
			intent = new Intent(this.getApplicationContext(), WriteReview.class);
			intent.putExtra("WaypointID", waypointID);
			startActivity(intent);
			break;
		}

	}

	class ListAdapter extends ArrayAdapter<Reply> {

		private ArrayList<Reply> items;

		public ListAdapter(Context context, int textViewResourceId,
				ArrayList<Reply> objects) {
			super(context, textViewResourceId, objects);
			// TODO Auto-generated constructor stub
			items = objects;
		}

		@Override
		public View getView(int position, View convertView, ViewGroup parent) {
			ViewHolder holder;
			View v = convertView;
			if (v == null) {
				LayoutInflater vi = (LayoutInflater) getSystemService(Context.LAYOUT_INFLATER_SERVICE);
				v = vi.inflate(R.layout.reviewlist_row, null);
				holder = new ViewHolder();
				holder.ratingbar = (RatingBar) v.findViewById(R.id.ratingbar);
				holder.reviewDate = (TextView) v.findViewById(R.id.date);
				holder.content = (TextView) v.findViewById(R.id.content);
				v.setTag(holder);
			} else {
				holder = (ViewHolder) v.getTag();
			}
			
			holder.ratingbar.setRating(items.get(position).getGrade());
			String dateStr= items.get(position).getReplydate();
			holder.reviewDate.setText(dateStr.substring(0, dateStr.indexOf(" ")));
			holder.content.setText(items.get(position).getContent());
			return v;
		}

	}

	static class ViewHolder {
		RatingBar ratingbar;
		TextView reviewDate;
		TextView content;

	}

}
