package PlayTravel.Database;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.StringReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.ArrayList;

import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserFactory;

import PlayTravel.Data.Album;
import PlayTravel.Data.Category;
import PlayTravel.Data.Local;
import PlayTravel.Data.Member;
import PlayTravel.Data.Reply;
import PlayTravel.Data.Theme;
import PlayTravel.Data.WayPoint;
import PlayTravel.Data.WayPointImg;
import android.util.Log;

public class DB {
	final static String URL = "http://211.189.20.69:8070/";
	public static String phoneNumber = "";
	
	// ȸ ִ ˻
	//  : ok - ȸ ְų  Ͽ־.. err - ѹ Ȯϰ Ѿ .. Ÿ -  ..
	public String checkMember(){
		try{
			String address = URL + "php/checkMember.php";
			URL url = new URL(address);
			HttpURLConnection conn = (HttpURLConnection)url.openConnection();
			conn.setDoOutput(true);
			conn.setUseCaches(false);
			conn.setRequestMethod("POST");
			
			DataOutputStream out = new DataOutputStream(conn.getOutputStream());
			String encoded =
				"phoneNumber=" + phoneNumber;
		    out.writeBytes(encoded);
		    out.flush();
		    out.close();
		    BufferedReader br = new BufferedReader(new InputStreamReader(conn.getInputStream()));
            String str = null;
            String resultString = "";
            while((str = br.readLine()) != null) {
            	resultString += str;
            }
            return resultString;
		}
		catch(Exception e){
			Log.e("Net", "Error in network call", e);
		}
		return null;
	}
	
	//  ٹ Ʈ ..
	//Ķ : flag - (1 :  ٹƮ    2 : ü ٹƮ    3 : ũ )
	// : ٹƮ(ArrayList<Album> - Album class)
	public ArrayList<Album> getAlbumList(int flag,Integer page,Integer pageCount, String localName, Integer themeID){
		ArrayList<Album> items = new ArrayList<Album>();
		 String resultString = "";
		 
		try {
           URL url = new URL(URL + "xml/getAlbumList.php");
			HttpURLConnection conn = (HttpURLConnection)url.openConnection();			
			conn.setDoOutput(true);
			conn.setUseCaches(false);
			conn.setRequestMethod("POST");
			DataOutputStream out = new DataOutputStream(conn.getOutputStream());
			String encoded =
				"phoneNumber=" + phoneNumber + 
				"&flag=" + flag + 
				"&page=" + page + 
				"&pageCount=" + pageCount + 
				"&localName=" + URLEncoder.encode(localName,"UTF-8") +
				"&themeID=" + themeID;
		    out.writeBytes(encoded);
		    out.flush();
		    out.close();
           XmlPullParserFactory parserCreator = XmlPullParserFactory.newInstance();
           XmlPullParser parser = parserCreator.newPullParser();
           BufferedReader br = new BufferedReader(new InputStreamReader(conn.getInputStream()));
           String str = null;
           while((str = br.readLine()) != null) {
           	resultString += str;
           }
           
           Log.d("db",resultString);
           
           parser.setInput(new StringReader(resultString));
           int parserEvent = parser.getEventType();
           Album item = new Album();
           while (parserEvent != XmlPullParser.END_DOCUMENT) {
               switch(parserEvent) {                
               case XmlPullParser.START_TAG:
            	   
               	if(parser.getName().equals("root")){    
               		item.setTotalPageCount(Integer.parseInt(parser.getAttributeValue(0)));
               	}
               	
               	if(parser.getName().equals("Album")){  
               		
               	}
               	
               	if (parser.getName().equals("ID")) {
               		item.setId(Integer.parseInt(parser.nextText()));               	
               	}
               	else if (parser.getName().equals("Name")) {
               		item.setName(parser.nextText());
               	}
               	else if (parser.getName().equals("Theme")) {
               		item.setThemeID(Integer.parseInt(parser.nextText()));
               	}
               	else if (parser.getName().equals("CreateDate")) {
               		item.setCreateDate(parser.nextText());
               	}
               	else if (parser.getName().equals("MemberID")) {
               		item.setMemID(Integer.parseInt(parser.nextText()));
               	}
            	else if (parser.getName().equals("ImgSrc")) {
               		item.setImgSrc(parser.nextText());
               	}
            	else if (parser.getName().equals("ThemeName")) {
               		item.setThemeName(parser.nextText());
               	}
            	else if (parser.getName().equals("Grade")) {
               		item.setGrade(Integer.parseInt(parser.nextText()));
               	}
            	else if (parser.getName().equals("OpenFlag")) {
               		item.setOpenFlag(Integer.parseInt(parser.nextText()));
               	}
            	else if (parser.getName().equals("wCount")) {
               		item.setwCount(Integer.parseInt(parser.nextText()));
               	}
            	else if (parser.getName().equals("MyFlag")) {
               		item.setMyFlag(Integer.parseInt(parser.nextText()));
               	}
               	
               	
                   break;
               case XmlPullParser.END_TAG:
               	if(parser.getName().equals("Album")){
               		items.add(new Album(item));  
               		item = new Album();
               	}
               }
               parserEvent = parser.next();                              
           }
           
       } catch (Exception e) {

           Log.e("Net", "Error in network call", e);
       }
      
       return items;
	}
	
	
	//ٹ ϳ  ..
	//Ķ : AlbumID
	// : ٹ(Album - Album class)
	public Album getAlbumInfo(Integer albumID){
		Album item = new Album();
		String resultString = "";
		 
		try {
           URL url = new URL(URL + "xml/getAlbumInfo.php");
			HttpURLConnection conn = (HttpURLConnection)url.openConnection();			
			conn.setDoOutput(true);
			conn.setUseCaches(false);
			conn.setRequestMethod("POST");
			DataOutputStream out = new DataOutputStream(conn.getOutputStream());
			String encoded =
				"albumID=" + albumID;
		    out.writeBytes(encoded);
		    out.flush();
		    out.close();
           XmlPullParserFactory parserCreator = XmlPullParserFactory.newInstance();
           XmlPullParser parser = parserCreator.newPullParser();
           BufferedReader br = new BufferedReader(new InputStreamReader(conn.getInputStream()));
           String str = null;
           while((str = br.readLine()) != null) {
           	resultString += str;
           }
           
           //Log.d("db",resultString);
           
           parser.setInput(new StringReader(resultString));
           int parserEvent = parser.getEventType();
           while (parserEvent != XmlPullParser.END_DOCUMENT) {
               switch(parserEvent) {                
               case XmlPullParser.START_TAG:
            	   
               	if(parser.getName().equals("root")){               		
               	}
               	
               	if(parser.getName().equals("Album")){  
               		
               	}
               	
               	if (parser.getName().equals("ID")) {
               		item.setId(Integer.parseInt(parser.nextText()));               	
               	}
               	else if (parser.getName().equals("Name")) {
               		item.setName(parser.nextText());
               	}
               	else if (parser.getName().equals("Theme")) {
               		item.setThemeID(Integer.parseInt(parser.nextText()));
               	}
               	else if (parser.getName().equals("CreateDate")) {
               		item.setCreateDate(parser.nextText());
               	}
               	else if (parser.getName().equals("MemberID")) {
               		item.setMemID(Integer.parseInt(parser.nextText()));
               	}
               	else if (parser.getName().equals("ImgSrc")) {
               		item.setImgSrc(parser.nextText());
               	}
               	
                   break;
               case XmlPullParser.END_TAG:
               	if(parser.getName().equals("Album")){
               	}
               }
               parserEvent = parser.next();                              
           }
           
       } catch (Exception e) {

           Log.e("Net", "Error in network call", e);
       }
      
       return item;
	}
	
	//ڽ з īװ  ..
	// : īװ(ArrayList<Category> - Category class)
	public ArrayList<Category> getCategoryList(){
		ArrayList<Category> items = new ArrayList<Category>();
		 String resultString = "";
		 
		try {
           URL url = new URL(URL + "xml/getCategory.php");
			HttpURLConnection conn = (HttpURLConnection)url.openConnection();			
			conn.setDoOutput(true);
			conn.setUseCaches(false);
			conn.setRequestMethod("POST");
			DataOutputStream out = new DataOutputStream(conn.getOutputStream());
			String encoded = "";
		    out.writeBytes(encoded);
		    out.flush();
		    out.close();
           XmlPullParserFactory parserCreator = XmlPullParserFactory.newInstance();
           XmlPullParser parser = parserCreator.newPullParser();
           BufferedReader br = new BufferedReader(new InputStreamReader(conn.getInputStream()));
           String str = null;
           while((str = br.readLine()) != null) {
           	resultString += str;
           }
           
           Log.d("db",resultString);
           
           parser.setInput(new StringReader(resultString));
           int parserEvent = parser.getEventType();
           Category item = new Category();
           while (parserEvent != XmlPullParser.END_DOCUMENT) {
               switch(parserEvent) {                
               case XmlPullParser.START_TAG:
            	   
               	if(parser.getName().equals("root")){               		
               	}
               	
               	if(parser.getName().equals("Category")){  
               		
               	}
               	
               	if (parser.getName().equals("ID")) {
               		item.setId(Integer.parseInt(parser.nextText()));               	
               	}
               	else if (parser.getName().equals("Name")) {
               		item.setName(parser.nextText());
               	}
                   break;
               case XmlPullParser.END_TAG:
               	if(parser.getName().equals("Category")){
               		items.add(new Category(item));  
               		item = new Category();
               	}
               }
               parserEvent = parser.next();                              
           }
           
       } catch (Exception e) {

           Log.e("Net", "Error in network call", e);
       }
      
       return items;
	}
	
	//īװ ϳ  ..
	// : īװ(Category - Category class)
	public Category getCategoryInfo(Integer categoryID){
		Category item = new Category();
		 String resultString = "";
		 
		try {
           URL url = new URL(URL + "xml/getCategoryInfo.php");
			HttpURLConnection conn = (HttpURLConnection)url.openConnection();			
			conn.setDoOutput(true);
			conn.setUseCaches(false);
			conn.setRequestMethod("POST");
			DataOutputStream out = new DataOutputStream(conn.getOutputStream());
			String encoded = 
				"categoryID=" + categoryID;
		    out.writeBytes(encoded);
		    out.flush();
		    out.close();
           XmlPullParserFactory parserCreator = XmlPullParserFactory.newInstance();
           XmlPullParser parser = parserCreator.newPullParser();
           BufferedReader br = new BufferedReader(new InputStreamReader(conn.getInputStream()));
           String str = null;
           while((str = br.readLine()) != null) {
           	resultString += str;
           }
           
           Log.d("test",resultString);
           
           parser.setInput(new StringReader(resultString));
           int parserEvent = parser.getEventType();
           while (parserEvent != XmlPullParser.END_DOCUMENT) {
               switch(parserEvent) {                
               case XmlPullParser.START_TAG:
            	   
               	if(parser.getName().equals("root")){               		
               	}
               	
               	if(parser.getName().equals("Category")){  
               		
               	}
               	
               	if (parser.getName().equals("ID")) {
               		item.setId(Integer.parseInt(parser.nextText()));               	
               	}
               	else if (parser.getName().equals("Name")) {
               		item.setName(parser.nextText());
               	}
                   break;
               case XmlPullParser.END_TAG:
               	if(parser.getName().equals("Category")){
               	}
               }
               parserEvent = parser.next();                              
           }
           
       } catch (Exception e) {

           Log.e("Net", "Error in network call", e);
       }
      
       return item;
	}
	
	
	//ȸ ..
	// : Member νϽ
	public Member getMemberInfo(){
		Member member = new Member();
		String resultString = "";
		
		try{
			String address = URL + "xml/getMember.php";
			URL url = new URL(address);
			HttpURLConnection conn = (HttpURLConnection)url.openConnection();
			conn.setDoOutput(true);
			conn.setUseCaches(false);
			conn.setRequestMethod("POST");
			
			DataOutputStream out = new DataOutputStream(conn.getOutputStream());
			String encoded =
				"phoneNumber=" + phoneNumber;
		    out.writeBytes(encoded);
		    out.flush();
		    out.close();
		    XmlPullParserFactory parserCreator = XmlPullParserFactory.newInstance();
	           XmlPullParser parser = parserCreator.newPullParser();
	           BufferedReader br = new BufferedReader(new InputStreamReader(conn.getInputStream()));
	           String str = null;
	           while((str = br.readLine()) != null) {
	           	resultString += str;
	           }
            
            Log.d("db",resultString);
            
            parser.setInput(new StringReader(resultString));
            int parserEvent = parser.getEventType();
            while (parserEvent != XmlPullParser.END_DOCUMENT) {
                switch(parserEvent) {                
                case XmlPullParser.START_TAG:
             	   
                	if(parser.getName().equals("root")){               		
                	}
                	
                	if(parser.getName().equals("Member")){  
                		
                	}
                	
                	if (parser.getName().equals("ID")) {
                		member.setId(Integer.parseInt(parser.nextText()));               	
                	}
                	else if (parser.getName().equals("PhoneNumber")) {
                		member.setPhoneNumber(parser.nextText());
                	}
                    break;
                case XmlPullParser.END_TAG:
                	if(parser.getName().equals("Member")){
                	}
                }
                parserEvent = parser.next();                              
            }
            
            return member;
		}
		catch(Exception e){
			Log.e("Net", "Error in network call", e);
		}
		return null;
	}
	
	//ش ڽ   ...
	//Ķ : ش ڽ id
	// : ش ڽ  Ʈ(ArrayList<Reply> - Reply class)
	public ArrayList<Reply> getReplyList(Integer wayPointID){
		ArrayList<Reply> items = new ArrayList<Reply>();
		 String resultString = "";
		 
		try {
           URL url = new URL(URL + "xml/getReply.php");
			HttpURLConnection conn = (HttpURLConnection)url.openConnection();			
			conn.setDoOutput(true);
			conn.setUseCaches(false);
			conn.setRequestMethod("POST");
			DataOutputStream out = new DataOutputStream(conn.getOutputStream());
			String encoded = "wayPointID=" + wayPointID;
		    out.writeBytes(encoded);
		    out.flush();
		    out.close();
           XmlPullParserFactory parserCreator = XmlPullParserFactory.newInstance();
           XmlPullParser parser = parserCreator.newPullParser();
           BufferedReader br = new BufferedReader(new InputStreamReader(conn.getInputStream()));
           String str = null;
           while((str = br.readLine()) != null) {
           	resultString += str;
           }
           
           Log.d("db",resultString);
           
           parser.setInput(new StringReader(resultString));
           int parserEvent = parser.getEventType();
           Reply item = new Reply();
           while (parserEvent != XmlPullParser.END_DOCUMENT) {
               switch(parserEvent) {                
               case XmlPullParser.START_TAG:
            	   
               	if(parser.getName().equals("root")){               		
               	}
               	
               	if(parser.getName().equals("Reply")){  
               		
               	}
               	
               	if (parser.getName().equals("ID")) {
               		item.setId(Integer.parseInt(parser.nextText()));               	
               	}
               	else if (parser.getName().equals("Content")) {
               		item.setContent(parser.nextText());
               	}
               	else if (parser.getName().equals("ReplyDate")) {
               		item.setReplydate(parser.nextText());
               	}
               	else if (parser.getName().equals("Grade")) {
               		item.setGrade(Integer.parseInt(parser.nextText()));
               	}
               	else if (parser.getName().equals("WayPointID")) {
               		item.setWaypointid(Integer.parseInt(parser.nextText()));
               	}
               	
                   break;
               case XmlPullParser.END_TAG:
               	if(parser.getName().equals("Reply")){
               		items.add(new Reply(item));  
               		item = new Reply();
               	}
               }
               parserEvent = parser.next();                              
           }
           
       } catch (Exception e) {

           Log.e("Net", "Error in network call", e);
       }
      
       return items;
	}
	
	
	//׸ з īװ  ..
	// : īװ(ArrayList<Theme> - Theme class)
	public ArrayList<Theme> getThemeList(){
		ArrayList<Theme> items = new ArrayList<Theme>();
		 String resultString = "";
		 
		try {
           URL url = new URL(URL + "xml/getTheme.php");
			HttpURLConnection conn = (HttpURLConnection)url.openConnection();			
			conn.setDoOutput(true);
			conn.setUseCaches(false);
			conn.setRequestMethod("POST");
			DataOutputStream out = new DataOutputStream(conn.getOutputStream());
			String encoded = "";
		    out.writeBytes(encoded);
		    out.flush();
		    out.close();
           XmlPullParserFactory parserCreator = XmlPullParserFactory.newInstance();
           XmlPullParser parser = parserCreator.newPullParser();
           BufferedReader br = new BufferedReader(new InputStreamReader(conn.getInputStream()));
           String str = null;
           while((str = br.readLine()) != null) {
           	resultString += str;
           }
           
           Log.d("dalbum",resultString);
           
           parser.setInput(new StringReader(resultString));
           int parserEvent = parser.getEventType();
           Theme item = new Theme();
           while (parserEvent != XmlPullParser.END_DOCUMENT) {
               switch(parserEvent) {                
               case XmlPullParser.START_TAG:
            	   
               	if(parser.getName().equals("root")){               		
               	}
               	
               	if(parser.getName().equals("Theme")){  
               		
               	}
               	
               	if (parser.getName().equals("ID")) {
               		item.setId(Integer.parseInt(parser.nextText()));               	
               	}
               	else if (parser.getName().equals("Name")) {
               		item.setName(parser.nextText());
               	}
                   break;
               case XmlPullParser.END_TAG:
               	if(parser.getName().equals("Theme")){
               		items.add(new Theme(item));  
               		item = new Theme();
               	}
               }
               parserEvent = parser.next();                              
           }
           
       } catch (Exception e) {

           Log.e("Net", "Error in network call", e);
       }
      
       return items;
	}
	
	//ش ٹ ڽ  ..
	//Ķ : ش ٹ ID
	// : ش ٹ ڽ(ArrayList<WayPoint> - WayPoint class)
	public ArrayList<WayPoint> getWayPointList(Integer albumID){
		ArrayList<WayPoint> items = new ArrayList<WayPoint>();
		 String resultString = "";
		 
		try {
           URL url = new URL(URL + "xml/getWaypoint.php");
			HttpURLConnection conn = (HttpURLConnection)url.openConnection();			
			conn.setDoOutput(true);
			conn.setUseCaches(false);
			conn.setRequestMethod("POST");
			DataOutputStream out = new DataOutputStream(conn.getOutputStream());
			String encoded = "albumID=" + albumID + 
			"phoneNumber=" + phoneNumber;
		    out.writeBytes(encoded);
		    out.flush();
		    out.close();
           XmlPullParserFactory parserCreator = XmlPullParserFactory.newInstance();
           XmlPullParser parser = parserCreator.newPullParser();
           BufferedReader br = new BufferedReader(new InputStreamReader(conn.getInputStream()));
           String str = null;
           while((str = br.readLine()) != null) {
           	resultString += str;
           }
           
           Log.d("db",resultString);
           
           parser.setInput(new StringReader(resultString));
           int parserEvent = parser.getEventType();
           WayPoint item = new WayPoint();
           while (parserEvent != XmlPullParser.END_DOCUMENT) {
               switch(parserEvent) {                
               case XmlPullParser.START_TAG:
            	   
               	if(parser.getName().equals("root")){               		
               	}
               	
               	if(parser.getName().equals("Waypoint")){  
               		
               	}
               	
               	if (parser.getName().equals("ID")) {
               		item.setId(Integer.parseInt(parser.nextText()));               	
               	}
               	else if (parser.getName().equals("Conment")) {
               		item.setComent(parser.nextText());
               	}
               	else if (parser.getName().equals("WayDate")) {
               		item.setWaydate(parser.nextText());
               	}
               	else if (parser.getName().equals("x")) {
               		item.setX(Double.parseDouble(parser.nextText()));
               	}
               	else if (parser.getName().equals("y")) {
               		item.setY(Double.parseDouble(parser.nextText()));
               	}
               	else if (parser.getName().equals("CategoryID")) {
               		item.setCategoryID(Integer.parseInt(parser.nextText()));
               	}
               	else if (parser.getName().equals("Adress")) {
               		item.setAdress(parser.nextText());
               	}
               	else if (parser.getName().equals("AlbumID")) {
               		item.setAlbumID(Integer.parseInt(parser.nextText()));
               	}
               	else if (parser.getName().equals("Flag")) {
               		item.setFlag(Integer.parseInt(parser.nextText()));
               	}
               	else if (parser.getName().equals("MyFlag")) {
               		item.setMyFlag(Integer.parseInt(parser.nextText()));
               	}
               	
                   break;
               case XmlPullParser.END_TAG:
               	if(parser.getName().equals("Waypoint")){
               		items.add(new WayPoint(item));  
               		item = new WayPoint();
               	}
               }
               parserEvent = parser.next();                              
           }
           
       } catch (Exception e) {

           Log.e("Net", "Error in network call", e);
       }
      
       return items;
	}
	
	
	//ش ٹ ڽ  ..
	//Ķ :  ̸
	// : ش ٹ ڽ(ArrayList<WayPoint> - WayPoint class)
	public ArrayList<WayPoint> getWayPointListWithLocalName(String local){
		ArrayList<WayPoint> items = new ArrayList<WayPoint>();
		 String resultString = "";
		 
		try {//
           URL url = new URL(URL + "xml/getWaypoint.php");
			HttpURLConnection conn = (HttpURLConnection)url.openConnection();			
			conn.setDoOutput(true);
			conn.setUseCaches(false);
			conn.setRequestMethod("POST");
			DataOutputStream out = new DataOutputStream(conn.getOutputStream());
			String encoded = "local=" + URLEncoder.encode(local,"UTF-8");
		    out.writeBytes(encoded);
		    out.flush();
		    out.close();
           XmlPullParserFactory parserCreator = XmlPullParserFactory.newInstance();
           XmlPullParser parser = parserCreator.newPullParser();
           BufferedReader br = new BufferedReader(new InputStreamReader(conn.getInputStream()));
           String str = null;
           while((str = br.readLine()) != null) {
           	resultString += str;
           }
           
           Log.d("db",resultString);
           
           parser.setInput(new StringReader(resultString));
           int parserEvent = parser.getEventType();
           WayPoint item = new WayPoint();
           while (parserEvent != XmlPullParser.END_DOCUMENT) {
               switch(parserEvent) {                
               case XmlPullParser.START_TAG:
            	   
               	if(parser.getName().equals("root")){               		
               	}
               	
               	if(parser.getName().equals("Waypoint")){  
               		
               	}
               	
               	if (parser.getName().equals("ID")) {
               		item.setId(Integer.parseInt(parser.nextText()));               	
               	}
               	else if (parser.getName().equals("Conment")) {
               		item.setComent(parser.nextText());
               	}
               	else if (parser.getName().equals("WayDate")) {
               		item.setWaydate(parser.nextText());
               	}
               	else if (parser.getName().equals("x")) {
               		item.setX(Double.parseDouble(parser.nextText()));
               	}
               	else if (parser.getName().equals("y")) {
               		item.setY(Double.parseDouble(parser.nextText()));
               	}
               	else if (parser.getName().equals("CategoryID")) {
               		item.setCategoryID(Integer.parseInt(parser.nextText()));
               	}
               	else if (parser.getName().equals("Adress")) {
               		item.setAdress(parser.nextText());
               	}
               	else if (parser.getName().equals("AlbumID")) {
               		item.setAlbumID(Integer.parseInt(parser.nextText()));
               	}
                   break;
               case XmlPullParser.END_TAG:
               	if(parser.getName().equals("Waypoint")){
               		items.add(new WayPoint(item));  
               		item = new WayPoint();
               	}
               }
               parserEvent = parser.next();                              
           }
           
       } catch (Exception e) {

           Log.e("Net", "Error in network call", e);
       }
      
       return items;
	}
	
	
	//ش ڽ(Ѱ)   ..
	//Ķ : ڽ ̵(waypointid)
	// : ش ڽ(Ѱ)(WayPoint - WayPoint class)
	public WayPoint getWayPointInfo(Integer wayPointID){
		 String resultString = "";
		 WayPoint item = new WayPoint();
		 
		try {
           URL url = new URL(URL + "xml/getWaypointInfo.php");
			HttpURLConnection conn = (HttpURLConnection)url.openConnection();			
			conn.setDoOutput(true);
			conn.setUseCaches(false);
			conn.setRequestMethod("POST");
			DataOutputStream out = new DataOutputStream(conn.getOutputStream());
			String encoded = "wayPointID=" + wayPointID;
		    out.writeBytes(encoded);
		    out.flush();
		    out.close();
           XmlPullParserFactory parserCreator = XmlPullParserFactory.newInstance();
           XmlPullParser parser = parserCreator.newPullParser();
           BufferedReader br = new BufferedReader(new InputStreamReader(conn.getInputStream()));
           String str = null;
           while((str = br.readLine()) != null) {
           	resultString += str;
           }
           
           Log.d("db",resultString);
           
           parser.setInput(new StringReader(resultString));
           int parserEvent = parser.getEventType();
          
           while (parserEvent != XmlPullParser.END_DOCUMENT) {
               switch(parserEvent) {                
               case XmlPullParser.START_TAG:
            	   
               	if(parser.getName().equals("root")){               		
               	}
               	
               	if(parser.getName().equals("Waypoint")){  
               		
               	}
               	
               	if (parser.getName().equals("ID")) {
               		item.setId(Integer.parseInt(parser.nextText()));               	
               	}
               	else if (parser.getName().equals("Conment")) {
               		item.setComent(parser.nextText());
               	}
               	else if (parser.getName().equals("WayDate")) {
               		item.setWaydate(parser.nextText());
               	}
               	else if (parser.getName().equals("x")) {
               		item.setX(Double.parseDouble(parser.nextText()));
               	}
               	else if (parser.getName().equals("y")) {
               		item.setY(Double.parseDouble(parser.nextText()));
               	}
               	else if (parser.getName().equals("CategoryID")) {
               		item.setCategoryID(Integer.parseInt(parser.nextText()));
               	}
               	else if (parser.getName().equals("Adress")) {
               		item.setAdress(parser.nextText());
               	}
               	else if (parser.getName().equals("AlbumID")) {
               		item.setAlbumID(Integer.parseInt(parser.nextText()));
               	}
               	else if (parser.getName().equals("Local")) {
               		item.setLocal(parser.nextText());
               	}
                   break;
               case XmlPullParser.END_TAG:
               	if(parser.getName().equals("Waypoint")){
               	}
               }
               parserEvent = parser.next();                              
           }
           
       } catch (Exception e) {

           Log.e("Net", "Error in network call", e);
       }
      
       return item;
	}
	
	
	//ش ڽ ̹  ..
	//Ķ : شڽ ID
	// : ش ڽ ̹(ArrayList<WayPointImg> - WayPointImg class)
	public ArrayList<WayPointImg> getWayPointImgList(Integer wayPointID){
		ArrayList<WayPointImg> items = new ArrayList<WayPointImg>();
		 String resultString = "";
		 
		try {
           URL url = new URL(URL + "xml/getWaypointImg.php");
			HttpURLConnection conn = (HttpURLConnection)url.openConnection();			
			conn.setDoOutput(true);
			conn.setUseCaches(false);
			conn.setRequestMethod("POST");
			DataOutputStream out = new DataOutputStream(conn.getOutputStream());
			String encoded = "wayPointID=" + wayPointID;
		    out.writeBytes(encoded);
		    out.flush();
		    out.close();
           XmlPullParserFactory parserCreator = XmlPullParserFactory.newInstance();
           XmlPullParser parser = parserCreator.newPullParser();
           BufferedReader br = new BufferedReader(new InputStreamReader(conn.getInputStream()));
           String str = null;
           while((str = br.readLine()) != null) {
           	resultString += str;
           }
           
           Log.d("basket",resultString);
           
           parser.setInput(new StringReader(resultString));
           int parserEvent = parser.getEventType();
           WayPointImg item = new WayPointImg();
           while (parserEvent != XmlPullParser.END_DOCUMENT) {
               switch(parserEvent) {                
               case XmlPullParser.START_TAG:
               	if(parser.getName().equals("root")){  
               	}
               	
               	if(parser.getName().equals("wayPointImg")){ 
               	}
               	
               	if (parser.getName().equals("ID")) {
               		item.setId(Integer.parseInt(parser.nextText()));  
               	}
               	else if (parser.getName().equals("Src")) {
               		item.setSrc(parser.nextText());
               		Log.d("basket",item.getSrc());
               	}
               	else if (parser.getName().equals("WaypointID")) {
               		item.setWayPointID(Integer.parseInt(parser.nextText()));
               	}
                   break;
               case XmlPullParser.END_TAG:
               	if(parser.getName().equals("wayPointImg")){
               		items.add(new WayPointImg(item));  
               		item = new WayPointImg();
               	}
               }
               parserEvent = parser.next();                              
           }
           
       } catch (Exception e) {

           Log.e("Net", "Error in network call", e);
       }      
       return items;
	}
	
	//ο ٹ 
	//  : ok -  err - 
	public String insertAlbum(String name, Integer themeID, Integer openFlag){
		try{
			String address = URL + "php/insertAlbum.php";
			URL url = new URL(address);
			HttpURLConnection conn = (HttpURLConnection)url.openConnection();
			conn.setDoOutput(true);
			conn.setUseCaches(false);
			conn.setRequestMethod("POST");
			
			DataOutputStream out = new DataOutputStream(conn.getOutputStream());
			String encoded =
				"phoneNumber=" + phoneNumber +
				"&name=" + URLEncoder.encode(name, "UTF-8") +
				"&theme=" + themeID + 
				"&openFlag=" + openFlag;
		    out.writeBytes(encoded);
		    out.flush();
		    out.close();
		    BufferedReader br = new BufferedReader(new InputStreamReader(conn.getInputStream()));
            String str = null;
            String resultString = "";
            while((str = br.readLine()) != null) {
            	resultString += str;
            }
            return resultString;
		}
		catch(Exception e){
			Log.e("Net", "Error in network call", e);
		}
		return null;
	}
	
	
	//ٹ  
	//  : ok -   err - 
	public String updateAlbum(String name, Integer themeID, Integer openFlag, Integer albumID){
		try{
			String address = URL + "php/updateAlbum.php";
			URL url = new URL(address);
			HttpURLConnection conn = (HttpURLConnection)url.openConnection();
			conn.setDoOutput(true);
			conn.setUseCaches(false);
			conn.setRequestMethod("POST");
			
			DataOutputStream out = new DataOutputStream(conn.getOutputStream());
			String encoded =
				"phoneNumber=" + phoneNumber +
				"&name=" + URLEncoder.encode(name, "UTF-8") +
				"&theme=" + themeID + 
				"&openFlag=" + openFlag +
				"&albumID=" + albumID;
		    out.writeBytes(encoded);
		    out.flush();
		    out.close();
		    BufferedReader br = new BufferedReader(new InputStreamReader(conn.getInputStream()));
            String str = null;
            String resultString = "";
            while((str = br.readLine()) != null) {
            	resultString += str;
            }
            return resultString;
		}
		catch(Exception e){
			Log.e("Net", "Error in network call", e);
		}
		return null;
	}
	
	
	//ο  
	//  : ok -  err - 
	public String insertReply(String content, Integer grade, Integer wayPointID){
		try{
			String address = URL + "php/insertReply.php";
			URL url = new URL(address);
			HttpURLConnection conn = (HttpURLConnection)url.openConnection();
			conn.setDoOutput(true);
			conn.setUseCaches(false);
			conn.setRequestMethod("POST");
			
			DataOutputStream out = new DataOutputStream(conn.getOutputStream());
			String encoded =
				"content=" + URLEncoder.encode(content, "UTF-8") +
				"&grade=" + grade +
				"&wayPointID=" + wayPointID;
		    out.writeBytes(encoded);
		    out.flush();
		    out.close();
		    BufferedReader br = new BufferedReader(new InputStreamReader(conn.getInputStream()));
            String str = null;
            String resultString = "";
            while((str = br.readLine()) != null) {
            	resultString += str;
            }
            return resultString;
		}
		catch(Exception e){
			Log.e("Net", "Error in network call", e);
		}
		return null;
	}
	
	
	//ο ڽ  
	//  : ok -  err - 
	public String insertWayPoint(String coment, Double x, Double y,Integer categoryID, String wAddress, Integer albumID,String local, ArrayList<String> imgs,Integer flag){
		try{
			try{
				
				
				DataOutputStream dos;
				String lineEnd = "\r\n";
				String twoHyphens = "--";
		
				String boundary = "*****";						
				   
				FileInputStream fileInputStream = null;
				String address = null;
				address = URL + "php/insertWayPoint.php?coment=" + URLEncoder.encode(coment,"UTF-8") + "&wAddress=" + URLEncoder.encode(wAddress,"UTF-8") + "&local=" + URLEncoder.encode(local,"UTF-8");
				URL url = new URL(address);
				HttpURLConnection conn = (HttpURLConnection)url.openConnection();
					
				  // Allow Inputs
				 conn.setDoInput(true);		
				 // Allow Outputs
				 conn.setDoOutput(true);		
				 // Don't use a cached copy.
				 conn.setUseCaches(false);
		
				 // Use a post method.
				conn.setRequestMethod("POST");
				
				conn.setRequestProperty("Connection", "Keep-Alive");
				conn.setRequestProperty("Content-Type", "multipart/form-data;boundary="+boundary);
				
				dos = new DataOutputStream( conn.getOutputStream() );
				
				
				for (Integer i = 0 ; i < imgs.size() ; i++)
				{	
					if (imgs.get(i).equals("")) continue;
					
					File file = new File(imgs.get(i));   
					
					Log.d("basket",imgs.get(i));
					
					fileInputStream  = new FileInputStream(file);	
					
					dos.writeBytes(twoHyphens + boundary + lineEnd);
					dos.writeBytes("Content-Disposition: form-data; name=\"Filedata_" + i.toString() + "\";filename=\"" + imgs.get(i) +"\"" + lineEnd);			
					dos.writeBytes(lineEnd);
					                                     
					int maxBufferSize=1024;
					int bytesAvailable = fileInputStream.available();
					int bufferSize = Math.min(bytesAvailable, maxBufferSize);
					byte[] buffer = new byte[bufferSize];
			
					// read file and write it into form...
			
					 int bytesRead = fileInputStream.read(buffer, 0, bufferSize);
			
					while (bytesRead > 0)
					{
					    dos.write(buffer, 0, bufferSize);
					    bytesAvailable = fileInputStream.available();
					    bufferSize = Math.min(bytesAvailable, maxBufferSize);
					    bytesRead = fileInputStream.read(buffer, 0, bufferSize);
					}
			
					// send multipart form data necesssary after file data...		
					dos.writeBytes(lineEnd);	
										
				}
				
				dos.writeBytes(twoHyphens + boundary + lineEnd);
				
				
				dos.writeBytes("Content-Disposition: form-data; name=\"x\"");
				dos.writeBytes(lineEnd);
				dos.writeBytes(lineEnd);		
				dos.writeBytes(x.toString());
				dos.writeBytes(lineEnd);
				dos.writeBytes(twoHyphens + boundary + lineEnd);
				
				dos.writeBytes("Content-Disposition: form-data; name=\"y\"");
				dos.writeBytes(lineEnd);
				dos.writeBytes(lineEnd);		
				dos.writeBytes(y.toString());
				dos.writeBytes(lineEnd);
				dos.writeBytes(twoHyphens + boundary + lineEnd);
				
				dos.writeBytes("Content-Disposition: form-data; name=\"flag\"");
				dos.writeBytes(lineEnd);
				dos.writeBytes(lineEnd);		
				dos.writeBytes(flag.toString());
				dos.writeBytes(lineEnd);
				dos.writeBytes(twoHyphens + boundary + lineEnd);
				 
				dos.writeBytes("Content-Disposition: form-data; name=\"categoryID\"");
				dos.writeBytes(lineEnd);
				dos.writeBytes(lineEnd);		
				dos.writeBytes(categoryID.toString());
				dos.writeBytes(lineEnd);
				dos.writeBytes(twoHyphens + boundary + lineEnd);
				
				dos.writeBytes("Content-Disposition: form-data; name=\"albumID\"");
				dos.writeBytes(lineEnd);
				dos.writeBytes(lineEnd);		
				dos.writeBytes(albumID.toString());
				dos.writeBytes(lineEnd);
				dos.writeBytes(twoHyphens + boundary + twoHyphens + lineEnd);
				
				fileInputStream.close();
				dos.flush();
				dos.close();
		
				String a = conn.getResponseMessage();
				System.out.println(a);
				
				
				 BufferedReader br = new BufferedReader(new InputStreamReader(conn.getInputStream()));
		            String str = null;
		            String resultString = "";
		            while((str = br.readLine()) != null) {
		            	resultString += str;
		            }
		            
		            Log.d("trace",resultString);
		            conn.disconnect();
		            Log.d("still",resultString);
		         return resultString;   
			}catch (Exception e) {
				Log.e("Net", "Error in network call", e);
			}
			return null;			
		}
		catch(Exception e){
			Log.e("Net", "Error in network call", e);
		}
		return null;
	}
	
	//ο ڽ  
	//  : ok -  err - 
	public String insertWayPointWidget(Double x, Double y, String wAddress, Integer albumID,String local){
		try{
			String address = URL + "php/insertWayPointWidget.php";
			URL url = new URL(address);
			HttpURLConnection conn = (HttpURLConnection)url.openConnection();
			conn.setDoOutput(true);
			conn.setUseCaches(false);
			conn.setRequestMethod("POST");
			
			DataOutputStream out = new DataOutputStream(conn.getOutputStream());
			String encoded =
				"x=" + x +
				"&y=" + y +
				"&wAddress=" + URLEncoder.encode(wAddress, "UTF-8") + 
				"&albumID=" + albumID + 
				"&local=" + URLEncoder.encode(local, "UTF-8");
		    out.writeBytes(encoded);
		    out.flush();
		    out.close();
		    BufferedReader br = new BufferedReader(new InputStreamReader(conn.getInputStream()));
            String str = null;
            String resultString = "";
            while((str = br.readLine()) != null) {
            	resultString += str;
            }
            return resultString;
		}catch (Exception e) {
			Log.e("Net", "Error in network call", e);
		}
		return null;
		
	}
	
	//ڽ  
	//  : ok -  err - 
	public String updateWayPoint(String coment, Double x, Double y,Integer categoryID, String wAddress, Integer albumID,String local, ArrayList<String> imgs, ArrayList<Integer> ids, Integer wayPointID, ArrayList<Integer> types){
		try{				
				DataOutputStream dos;
				String lineEnd = "\r\n";
				String twoHyphens = "--";
		
				String boundary = "*****";						
				   
				FileInputStream fileInputStream = null;
				String address = null;
				address = address = URL + "php/updateWayPoint.php?coment=" + URLEncoder.encode(coment,"UTF-8") + "&wAddress=" + URLEncoder.encode(wAddress,"UTF-8") + "&local=" + URLEncoder.encode(local,"UTF-8");
				URL url = new URL(address);
				HttpURLConnection conn = (HttpURLConnection)url.openConnection();
					
				  // Allow Inputs
				 conn.setDoInput(true);		
				 // Allow Outputs
				 conn.setDoOutput(true);		
				 // Don't use a cached copy.
				 conn.setUseCaches(false);
		
				 // Use a post method.
				conn.setRequestMethod("POST");
				
				conn.setRequestProperty("Connection", "Keep-Alive");
				conn.setRequestProperty("Content-Type", "multipart/form-data;boundary="+boundary);
				
				dos = new DataOutputStream( conn.getOutputStream() );
				
				Integer tmpCount = 0;
								
				for (Integer i = 0 ; i < imgs.size() ; i++)
				{	
					if ((types.get(i) != 1 && types.get(i) != 2))
					{
						continue;
					}
					tmpCount++;
					
					File file = new File(imgs.get(i));                   
					
					fileInputStream  = new FileInputStream(file);//							
					
					dos.writeBytes(twoHyphens + boundary + lineEnd);
					dos.writeBytes("Content-Disposition: form-data; name=\"Filedata_" + i.toString() + "\";filename=\"" + imgs.get(i) +"\"" + lineEnd);			
					dos.writeBytes(lineEnd);
					                                     
					int maxBufferSize=1024;
					int bytesAvailable = fileInputStream.available();
					int bufferSize = Math.min(bytesAvailable, maxBufferSize);
					byte[] buffer = new byte[bufferSize];
			
					// read file and write it into form...
			
					int bytesRead = fileInputStream.read(buffer, 0, bufferSize);
			
					while (bytesRead > 0)
					{
					    dos.write(buffer, 0, bufferSize);
					    bytesAvailable = fileInputStream.available();
					    bufferSize = Math.min(bytesAvailable, maxBufferSize);
					    bytesRead = fileInputStream.read(buffer, 0, bufferSize);
					}
			
					// send multipart form data necesssary after file data...		
					dos.writeBytes(lineEnd);	
					fileInputStream.close();										
				}
				
					dos.writeBytes(twoHyphens + boundary + lineEnd);
				
				
				
				dos.writeBytes("Content-Disposition: form-data; name=\"x\"");
				dos.writeBytes(lineEnd);
				dos.writeBytes(lineEnd);		
				dos.writeBytes(x.toString());
				dos.writeBytes(lineEnd);
				dos.writeBytes(twoHyphens + boundary + lineEnd);
				
				dos.writeBytes("Content-Disposition: form-data; name=\"y\"");
				dos.writeBytes(lineEnd);
				dos.writeBytes(lineEnd);		
				dos.writeBytes(y.toString());
				dos.writeBytes(lineEnd);
				dos.writeBytes(twoHyphens + boundary + lineEnd);
				 
				dos.writeBytes("Content-Disposition: form-data; name=\"categoryID\"");
				dos.writeBytes(lineEnd);
				dos.writeBytes(lineEnd);		
				dos.writeBytes(categoryID.toString());
				dos.writeBytes(lineEnd);
				dos.writeBytes(twoHyphens + boundary + lineEnd);
				
				String tmpIDs = "";
				
				for (Integer i = 0 ; i < ids.size() ; i++)
				{
					tmpIDs = tmpIDs + ids.get(i).toString() + ",";
				}
				Log.d("modify","ids : " + tmpIDs);
				dos.writeBytes("Content-Disposition: form-data; name=\"ids\"");
				dos.writeBytes(lineEnd);
				dos.writeBytes(lineEnd);		
				dos.writeBytes(tmpIDs);
				dos.writeBytes(lineEnd);
				dos.writeBytes(twoHyphens + boundary + lineEnd);
				
				
				String tmpTypes = "";
				
				for (Integer i = 0 ; i < types.size() ; i++)
				{
					tmpTypes = tmpTypes + types.get(i).toString() + ",";
				}
				Log.d("modify","ids : " + tmpIDs);
				Log.d("modify","types : " + tmpTypes);
				dos.writeBytes("Content-Disposition: form-data; name=\"types\"");
				dos.writeBytes(lineEnd);
				dos.writeBytes(lineEnd);		
				dos.writeBytes(tmpTypes);
				dos.writeBytes(lineEnd);
				dos.writeBytes(twoHyphens + boundary + lineEnd);
				
				dos.writeBytes("Content-Disposition: form-data; name=\"wayPointID\"");
				dos.writeBytes(lineEnd);
				dos.writeBytes(lineEnd);		
				dos.writeBytes(wayPointID.toString());
				dos.writeBytes(lineEnd);
				dos.writeBytes(twoHyphens + boundary + lineEnd);
				
				
				dos.writeBytes("Content-Disposition: form-data; name=\"albumID\"");
				dos.writeBytes(lineEnd);
				dos.writeBytes(lineEnd);		
				dos.writeBytes(albumID.toString());
				dos.writeBytes(lineEnd);
				dos.writeBytes(twoHyphens + boundary + twoHyphens + lineEnd);
				
				//
				
				
				dos.flush();
				dos.close();
		
				String a = conn.getResponseMessage();
				System.out.println(a);
				
				
				 BufferedReader br = new BufferedReader(new InputStreamReader(conn.getInputStream()));
		            String str = null;
		            String resultString = "";
		            while((str = br.readLine()) != null) {
		            	resultString += str;
		            }
		            
		            Log.d("modify",resultString);
		            conn.disconnect();
		         return resultString;   						
		}
		catch(Exception e){
			Log.e("Net", "Error in network call", e);
		}
		return null;
	}	
	
	
	// ٹ ID ...
	//  : ٹ̵(ٹ̵ > 0 ) -      err -     ϵ ٹ  
	public String getLastAlbumID(){
		try{
			String address = URL + "xml/getLastAlbumID.php";
			URL url = new URL(address);
			HttpURLConnection conn = (HttpURLConnection)url.openConnection();
			conn.setDoOutput(true);
			conn.setUseCaches(false);
			conn.setRequestMethod("POST");
			
			DataOutputStream out = new DataOutputStream(conn.getOutputStream());
			String encoded =
				"phoneNumber=" + phoneNumber;
		    out.writeBytes(encoded);
		    out.flush();
		    out.close();
		    BufferedReader br = new BufferedReader(new InputStreamReader(conn.getInputStream()));
            String str = null;
            String resultString = "";
            while((str = br.readLine()) != null) {
            	resultString += str;
            }
            return resultString;
		}
		catch(Exception e){
			Log.e("Net", "Error in network call", e);
		}
		return null;
	}	
	
	//ٹ
	//Ķ : AlbumID
	//  : ok -  err - 
	public String deleteAlbum(Integer albumID){
		try{
			String address = URL + "php/delAlbum.php";
			URL url = new URL(address);
			HttpURLConnection conn = (HttpURLConnection)url.openConnection();
			conn.setDoOutput(true);
			conn.setUseCaches(false);
			conn.setRequestMethod("POST");
			
			DataOutputStream out = new DataOutputStream(conn.getOutputStream());
			String encoded =
				"albumID=" + albumID;
		    out.writeBytes(encoded);
		    out.flush();
		    out.close();
		    BufferedReader br = new BufferedReader(new InputStreamReader(conn.getInputStream()));
            String str = null;
            String resultString = "";
            while((str = br.readLine()) != null) {
            	resultString += str;
            }
            return resultString;
		}
		catch(Exception e){
			Log.e("Net", "Error in network call", e);
		}
		return null;
	}
	
	//ڽ
	//Ķ : ڽID
	//  : ok -  err - 
	public String deleteWayPoint(Integer wayPointID){
		try{
			String address = URL + "php/delWayPoint.php";
			URL url = new URL(address);
			HttpURLConnection conn = (HttpURLConnection)url.openConnection();
			conn.setDoOutput(true);
			conn.setUseCaches(false);
			conn.setRequestMethod("POST");
			
			DataOutputStream out = new DataOutputStream(conn.getOutputStream());
			String encoded =
				"wayPointID=" + wayPointID;
		    out.writeBytes(encoded);
		    out.flush();
		    out.close();
		    BufferedReader br = new BufferedReader(new InputStreamReader(conn.getInputStream()));
            String str = null;
            String resultString = "";
            while((str = br.readLine()) != null) {
            	resultString += str;
            }
            return resultString;
		}
		catch(Exception e){
			Log.e("Net", "Error in network call", e);
		}
		return null;
	}
	
	//ũϱ
	//Ķ : ũ waypointid
	//  : ok -   exist - ̵̹ϵ  err -  
	public String insertScrap(Integer albumID){
		try{
			String address = URL + "php/insertScrap.php";
			URL url = new URL(address);
			HttpURLConnection conn = (HttpURLConnection)url.openConnection();
			conn.setDoOutput(true);
			conn.setUseCaches(false);
			conn.setRequestMethod("POST");
			
			DataOutputStream out = new DataOutputStream(conn.getOutputStream());
			String encoded =
				"albumID=" + albumID + 
				"&phoneNumber=" + phoneNumber;
		    out.writeBytes(encoded);
		    out.flush();
		    out.close();
		    BufferedReader br = new BufferedReader(new InputStreamReader(conn.getInputStream()));
            String str = null;
            String resultString = "";
            while((str = br.readLine()) != null) {
            	resultString += str;
            }
            return resultString;
		}
		catch(Exception e){
			Log.e("Net", "Error in network call", e);
		}
		return null;
	}
	
	//ũüũϱ
	//Ķ : ũüũ waypointid
	//  : ok -   exist - ̵̹ϵ  err -  
	public String checkScrap(Integer albumID){
		try{
			String address = URL + "xml/getScrapInfo.php";
			URL url = new URL(address);
			HttpURLConnection conn = (HttpURLConnection)url.openConnection();
			conn.setDoOutput(true);
			conn.setUseCaches(false);
			conn.setRequestMethod("POST");
			
			DataOutputStream out = new DataOutputStream(conn.getOutputStream());
			String encoded =
				"albumID=" + albumID + 
				"&phoneNumber=" + phoneNumber;
		    out.writeBytes(encoded);
		    out.flush();
		    out.close();
		    BufferedReader br = new BufferedReader(new InputStreamReader(conn.getInputStream()));
            String str = null;
            String resultString = "";
            while((str = br.readLine()) != null) {
            	resultString += str;
            }
            return resultString;
		}
		catch(Exception e){
			Log.e("Net", "Error in network call", e);
		}
		return null;
	}
	
	//ũϱ
	//Ķ : ũ waypointid
	//  : ok -    err -  
	public String delScrap(Integer albumID){
		try{
			String address = URL + "php/delScrapInfo.php";
			URL url = new URL(address);
			HttpURLConnection conn = (HttpURLConnection)url.openConnection();
			conn.setDoOutput(true);
			conn.setUseCaches(false);
			conn.setRequestMethod("POST");
			
			DataOutputStream out = new DataOutputStream(conn.getOutputStream());
			String encoded =
				"albumID=" + albumID + 
				"&phoneNumber=" + phoneNumber;
		    out.writeBytes(encoded);
		    out.flush();
		    out.close();
		    BufferedReader br = new BufferedReader(new InputStreamReader(conn.getInputStream()));
            String str = null;
            String resultString = "";
            while((str = br.readLine()) != null) {
            	resultString += str;
            }
            Log.d("db",resultString);
            return resultString;
		}
		catch(Exception e){
			Log.e("Net", "Error in network call", e);
		}
		return null;
	}
	

	// ..
	// : (ArrayList<Local> - Local class)
	public ArrayList<Local> getLocalList(){
		ArrayList<Local> items = new ArrayList<Local>();
		 String resultString = "";
		 
		try {
	       URL url = new URL(URL + "xml/getLocalNames.php");
			HttpURLConnection conn = (HttpURLConnection)url.openConnection();			
			conn.setDoOutput(true);
			conn.setUseCaches(false);
			conn.setRequestMethod("POST");
			DataOutputStream out = new DataOutputStream(conn.getOutputStream());
			String encoded = "";
		    out.writeBytes(encoded);
		    out.flush();
		    out.close();
	       XmlPullParserFactory parserCreator = XmlPullParserFactory.newInstance();
	       XmlPullParser parser = parserCreator.newPullParser();
	       BufferedReader br = new BufferedReader(new InputStreamReader(conn.getInputStream()));
	       String str = null;
	       while((str = br.readLine()) != null) {
	       	resultString += str;
	       }
	       
	       Log.d("db",resultString);
	       
	       parser.setInput(new StringReader(resultString));
	       int parserEvent = parser.getEventType();
	       Local item = new Local();
	       while (parserEvent != XmlPullParser.END_DOCUMENT) {
	           switch(parserEvent) {                
	           case XmlPullParser.START_TAG:
	        	   
	           	if(parser.getName().equals("root")){               		
	           	}
	           	
	           	if(parser.getName().equals("Local")){  
	           		
	           	}
	           	
	           	if (parser.getName().equals("Name")) {
	           		item.setName(parser.nextText());
	           	}
	               break;
	           case XmlPullParser.END_TAG:
	           	if(parser.getName().equals("Local")){
	           		items.add(new Local(item));  
	           		item = new Local();
	           	}
	           }
	           parserEvent = parser.next();                              
	       }
	       
	   } catch (Exception e) {

	       Log.e("Net", "Error in network call", e);
	   }
	  
	   return items;
	}

}
