package PlayTravel.Map;

import java.io.IOException;
import java.util.ArrayList;

import PlayTravel.Activity.R;
import PlayTravel.Activity.MyLocationSetting.AddressSetting;
import PlayTravel.Activity.LocationModify.MaddressSetting;
import android.content.Context;
import android.graphics.drawable.Drawable;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.ItemizedOverlay;
import com.google.android.maps.MapView;
import com.google.android.maps.OverlayItem;

public class MyLocationOverlay extends ItemizedOverlay<OverlayItem>  {
	private ArrayList<OverlayItem> mOverlays = new ArrayList<OverlayItem>();
	private Context mContext;
	private AddressSetting mAddress;
	private MaddressSetting mAddress2;
	private boolean modifyFlag;
 
 public MyLocationOverlay(Context context, Drawable marker, AddressSetting address) {
	  super(marker);
	  mContext = context;
	  mAddress = address;
	  modifyFlag = false;
	 }

 public MyLocationOverlay(Context context, Drawable marker, MaddressSetting address) {
	  super(marker);
	  mContext = context;
	  mAddress2 = address;
	  modifyFlag = true;
	 }

 @Override
 protected OverlayItem createItem(int i) {
  return mOverlays.get(i); 
 }

@Override
public void setOnFocusChangeListener(OnFocusChangeListener l) {
	super.setOnFocusChangeListener(l);
}

@Override
 public int size() {
  return  mOverlays.size();
 }
 
 public void addOverlay(OverlayItem overlay, Drawable marker) { 
     mOverlays.add(overlay); 
     boundCenterBottom(marker);
     populate(); 
 }

@Override
public boolean onTap(GeoPoint p, MapView mapView) {
	
	// Ŭ  Ŀ ̵Ų.
	Drawable marker = mContext.getResources().getDrawable(R.drawable.icon_me);
	 marker.setBounds(0, 0, marker.getIntrinsicWidth(), marker.getIntrinsicHeight());
	 mOverlays.clear();
     OverlayItem item = new OverlayItem(p, "", "");
     item.setMarker(marker);
     addOverlay(item, marker);
     
     //ּ ϴ Լ ȣ
     try {
    	 if(modifyFlag){
    		 mAddress2.setAddress((double)p.getLatitudeE6()/1000000, (double)p.getLongitudeE6()/1000000);
    	 }else{
    		 mAddress.setAddress((double)p.getLatitudeE6()/1000000, (double)p.getLongitudeE6()/1000000);
    	 }
		
	} catch (IOException e) {
		e.printStackTrace();
	}
     
     
	return super.onTap(p, mapView);
}

}