package PlayTravel.Map;

import java.util.ArrayList;

import PlayTravel.Activity.NearMapView.NearMapDescription;
import PlayTravel.Data.WayPoint;
import android.content.Context;
import android.graphics.drawable.Drawable;
import android.util.Log;

import com.google.android.maps.ItemizedOverlay;
import com.google.android.maps.OverlayItem;

public class NearMapOverlay extends ItemizedOverlay<OverlayItem> {
	private ArrayList<OverlayItem> mOverlays = new ArrayList<OverlayItem>();
	private NearMapDescription mDescription;
	private Context mContext;
	private ArrayList<WayPoint> list;
	private int beforeIndex;
 

 public NearMapOverlay(Context context, Drawable marker, ArrayList<WayPoint> list, NearMapDescription description) {
	  super(marker);
	  mContext = context;
	  mDescription = description; 
	  this.list = list;
	  beforeIndex = 0;
}

 @Override
 protected OverlayItem createItem(int i) {
  return mOverlays.get(i); 
 }

@Override
public void setOnFocusChangeListener(OnFocusChangeListener l) {
	super.setOnFocusChangeListener(l);
}

@Override
 public int size() {
  return  mOverlays.size();
 }
 
 public void addOverlay(OverlayItem overlay, Drawable marker) { 
     mOverlays.add(overlay); 
     boundCenterBottom(marker);
     populate(); 
 }

 @Override 
 protected boolean onTap(int index) { 
	 
	 if(beforeIndex != index){  //  ٸ Ŀ ŬѰ
		 OverlayItem item = mOverlays.get(index);
		 OverlayItem beforeItem = mOverlays.get(beforeIndex);
	
		 Marker res = new Marker();
		 Drawable marker = null;
	 
		 if(beforeIndex != 0){   // ó Ŭ߰ų Ŀ ġ  ,  Ŀ ۰ϴ κ
			 marker = mContext.getResources().getDrawable(res.getId(0, list.get(beforeIndex-1).getCategoryID()));
			 marker.setBounds(0, 0, marker.getIntrinsicWidth(), marker.getIntrinsicHeight());
			 beforeItem.setMarker(marker);
			 boundCenterBottom(marker);
	//		 populate(); 
		 }
	 
		 if(index != 0){  // Ŭ Ŀ ũ ϴ  , ġ Ŀ ũ 
			 mDescription.setDescription(index-1);  // â  
			 marker = mContext.getResources().getDrawable(res.getId(1, list.get(index-1).getCategoryID()));
			 marker.setBounds(0, 0, marker.getIntrinsicWidth(), marker.getIntrinsicHeight());
			 item.setMarker(marker);
			 boundCenterBottom(marker);
	//		 populate(); 
		 }
		 beforeIndex = index;
	 }
	 
	 // Ŀ Ŭ  â ִ  ٽ ֵ
	 else{
		 if(index != 0){
			 mDescription.setVisible();
		 }
	 }
   return true; 
 }

}